VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BnetBot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'----------------------------------------------------------
'  Myriad
'  Common Bot Platform
'  Copyright  2003-2004 Eric Naeseth.
'----------------------------------------------------------
'  Version 2.2.0 (2004-06-12)
'  2.0.0: First recorded version. (Cloaked)
'  2.0.1: Added new evGetOps event. (Cloaked)
'  2.0.2: Added BinaryRejoin. (Cloaked)
'  2.0.3: Added HasOps tracking. (Cloaked)
'  2.1.0: Added profile read/write. (Cloaked)
'  2.2.0: Merged with Myriad's updated class. (Cloaked)
'----------------------------------------------------------
'  Dependencies:
'  myriad.dll
'  Winsock.bas
'----------------------------------------------------------

Private S As New Arbiter, BNLS As Arbiter, MCP As Arbiter

Private Const DEFAULT_REGISTER As String = "Major`Bot"

Public Enum bnProduct
    bpStarCraft
    bpBroodWar
    bpDiablo2
    bpDiablo2x
    bpWarCraft2
    bpWarCraft3
    bpWarCraft3x
    bpStarCraftSW
    bpDiablo
    bpDiabloSW
    bpChat
    bpStarCraftJapan
    bpBlizzard
    bpBnetRep
End Enum

Private Const PRODUCT_STARCRAFT& = &H1
Private Const PRODUCT_BROODWAR& = &H2
Private Const PRODUCT_WAR2BNE& = &H3
Private Const PRODUCT_DIABLO2& = &H4
Private Const PRODUCT_LORDOFDESTRUCTION& = &H5
Private Const PRODUCT_JAPANSTARCRAFT& = &H6
Private Const PRODUCT_WARCRAFT3& = &H7
Private Const PRODUCT_THEFROZENTHRONE& = &H8

' Events
Public Enum bnEvent
    evConError
    evConnect
    evBnlsConnect
    evBnlsDisconnect
    evDisconnect
    evConMsg
    evBroadcast
    evTalk
    evEmote
    evWhisperSend
    evWhisperRecv
    evJoin
    evPart
    evChannel
    evUser
    evError
    evInfo
    evSelfTalk
    evBot
    evDbg
    evGetOps
    evRegisterEmail
    evConnecting
    evBnlsConnecting
    evProxyConnecting
    evProxyConnect
    evSuccess
    evJoinedChannel
    evUserFlags
    evRealmConnecting
    evRealmConnect
    evRealmDisconnect
    evRealmStarted
    evRealmStartFailure
    evRealmCharList
    evRealmMOTD
    evRealmCharCreated
    evRealmCharCreateErr
    evRealmCharLogon
    evRealmCharLogonErr
    evRealmCharUpgraded
    evBuildList
End Enum

' Icons
Public Enum bnIcons
    BLIZ = 1
    BNET = 2
    CHAT = 3
    D2DV = 4
    D2XP = 5
    DRTL = 6
    DSHR = 7
    JSTR = 8
    MEGA = 9
    OPER = 10
    UNKN = 11
    SEXP = 12
    SPWN = 13
    SQEL = 14
    SSHR = 15
    STAR = 16
    W2BN = 17
    W3XP = 18
    WAR3 = 19
End Enum

Public Enum prxType
    socks4
    socks5
End Enum

'Private Const CRC32_POLYNOMIAL As Long = &HEDB88320
'Private CRC32Table(0 To 255) As Long

'-----------------------------------------------------------------------------------
'  Hashed Connections
'-----------------------------------------------------------------------------------
Private Declare Function CheckVersion Lib "myriad.dll" _
    (ByVal lpszFileName1 As String, ByVal lpszFileName2 As String, ByVal lpszFilename3 As String, _
    ByVal lpszValueString As String, lpdwVersion As Long, lpdwChecksum As Long, _
    ByVal lpExeInfoString As String, ByVal lpszMpqFileName As String) As Long
Private Declare Function GetPasswordHash Lib "myriad.dll" Alias "PasswordHash" _
    (ByVal Outbuf As String, ByVal ServerToken As Long, ByVal Password As String) As Long
Private Declare Function PasswordHashEx Lib "myriad.dll" _
    (ByVal Outbuf As String, ByVal clientKey As Long, ByVal ServerToken As Long, _
    ByVal Password As String) As Long
Private Declare Function CDKeyHash Lib "myriad.dll" _
    (ByVal Outbuf As String, ByVal lpszCDKey As String, ByVal dwServerHashKey As Long) _
    As Long
Private Declare Function CDKeyHashEx Lib "myriad.dll" (ByVal Outbuf As String, _
    ByVal lpszCDKey As String, ByVal dwClientKey As Long, ByVal dwServerToken As Long) As Long
Private Declare Function CreateHash Lib "myriad.dll" Alias "CreateAccount" _
    (ByVal Outbuf As String, ByVal Password As String)
Private Declare Sub CalcHashBuf Lib "myriad.dll" _
    (Outbuf As Any, Inbuf As Any, ByVal Length As Integer)
    
'-----------------------------------------------------------------------------------
'  Other myriad.dll Functions
'-----------------------------------------------------------------------------------
Private Declare Function BNLSChecksum Lib "myriad.dll" (ByVal Password As String, _
    ByVal ServerCode As Long) As Long

Private Declare Function GetUserDefaultLangID Lib "kernel32" () As Integer
Private Declare Function GetUserDefaultLCID Lib "kernel32" () As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" _
    (lpFileTime As Filetime, lpSystemTime As SystemTime) As Boolean
'Private Declare Function WideCharToMultiByte Lib "kernel32" _
    (ByVal CodePage As Long, ByVal dwFlags As Long, lpWideCharStr As String, _
    ByVal cchWideChar As Long, lpMultiByteStr As String, ByVal cbMultiByte As Long, _
    lpDefaultChar As String, lpUsedDefaultChar As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As String, ByVal cchMultiByte As Long, ByVal lpWideCharStr As String, ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As String, ByVal cchWideChar As Long, ByVal lpMultiByteStr As String, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Const CP_ACP = 0
Private Const CP_UTF8 = 65001
'Private Declare Function SetTimer Lib "user32" _
    (ByVal hWnd As Long, _
    ByVal nIDEvent As Long, _
    ByVal uElapse As Long, _
    ByVal lpTimerFunc As Long) As Long
'Private Declare Function KillTimer Lib "user32" _
    (ByVal hWnd As Long, _
    ByVal nIDEvent As Long) As Long


Private Type Filetime
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SystemTime
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

'-----------------------------------------------------------------------------------
'  BNLS Result Variables
'-----------------------------------------------------------------------------------
Private VerByte&, UseNLS As Boolean, IX86File$, ChecksumFormula$, CDKeyData$, _
    ExCDKeyData$, ClientSession&, ServerSession&, RegRequired As Boolean
    
'-----------------------------------------------------------------------------------
'  Operational Status
'-----------------------------------------------------------------------------------
Private JoiningChannel As Boolean, JoinTarget As String, _
    CreatingAccount As Boolean, RequestingStats As Boolean, ClanCandidates() As String, _
    BNOD$, BNOL&, LastNullSent&, Verbose As Boolean, PCStage As Long, PasswordHash As String, _
    MCPChunk As String, RUniqueUsername$, HasJoinedChannel As Boolean
Public Channel As String, UsersInChannel As Integer, TalkOK As Boolean, _
    GotCandidates As Boolean, FCStatus As Byte, ClanCreateSuccess As Boolean, _
    HasOps As Boolean

'-----------------------------------------------------------------------------------
'  Users in Channel Iterator
'-----------------------------------------------------------------------------------
Private UserI As Long

'-----------------------------------------------------------------------------------
'  Bot Information
'-----------------------------------------------------------------------------------
Public Username$, Password$, Server$, RealUsername$, Client As bnProduct, _
    CDKey$, ExCDKey$, Home$, Register$, Trigger$, UseBNLS As Boolean, _
    Proxy As Boolean, ProxyServer$, ProxyInit As Boolean, ProxyPort As Integer, _
    ProxyType As prxType, ProxyUser$, ProxyPassword$, bKey$, Profile$, UseRealm As Boolean, _
    Character As String, Realm As String
Private ChannelUsers As New Collection, SpamUsers As New Collection

'-----------------------------------------------------------------------------------
'  Hash Files
'-----------------------------------------------------------------------------------
'  StarCraft/Brood War/WarCraft II BNE
'  Hash1: StarCraft.exe or WarCraft II BNE.exe
'  Hash2: storm.dll
'  Hash3: battle.snp
'-----------------------------------------------------------------------------------
'  Diablo II/Lord of Destruction
'  Hash1: Game.exe
'  Hash2: Bnclient.dll
'  Hash3: D2Client.dll
'-----------------------------------------------------------------------------------
Public Hash1 As String, Hash2 As String, Hash3 As String

'-----------------------------------------------------------------------------------
'  Profile Requests
'-----------------------------------------------------------------------------------
Private Type RequestInfo
    User As String
    Keys() As String
End Type
Private PendingProfileRequests() As RequestInfo

'-----------------------------------------------------------------------------------
'  Queue
'-----------------------------------------------------------------------------------
Private MsgQueue As New Collection, LastTick As Long

Private Sub Class_Initialize()
    ProxyInit = False
    JoiningChannel = False
    RegRequired = False
    Proxy = False
    TalkOK = False
    CreatingAccount = False
    RequestingStats = False
    GotCandidates = False
    UserI = 1
    ClanCreateSuccess = False
    Verbose = False
End Sub

Public Function Connect() As Boolean
    'Load frmMain.txtRecv(0)
    Dim tR As Integer
    PCStage = 0
    HasJoinedChannel = False
    RealUsername = Username
    If UseBNLS Then
        Set BNLS = New Arbiter
        tR = frmMain.txtRecv.Count
        Load frmMain.txtRecv(tR)
        If BNLS.Initialize(frmMain.txtRecv(tR).hWnd, bKey, sBNLS) Then
            BotEvent bKey, evBnlsConnecting
            If Not BNLS.Connect("bnls.valhallalegends.com", 9367) Then
                BotEvent bKey, evConError, "Could not connect to BNLS."
            End If
        Else
            BotEvent bKey, evConError, "Could not initialize BNLS socket."
        End If
    Else
        If SupportsHashedClient(Client) Then
            ConnectToBattleNet
        Else
            BotEvent bKey, evConError, "Cannot connect using a hashed connection as a " & _
                ClientKeyToName(Client) & " client."
        End If
    End If
End Function

Public Function Disconnect() As Boolean
On Error Resume Next
    BNLS.Disconnect
    S.Disconnect
    BotEvent bKey, evDisconnect
On Error GoTo D_End
    MCP.Disconnect
    BotEvent bKey, evRealmDisconnect
D_End:
End Function

Public Sub SocketEvent(EventType As mSocketEvent, SocketType As mSocketType, _
    Optional Data As String, Optional Length As Long)
    
    Select Case EventType
        Case sConnect
            Select Case SocketType
                Case sBNLS
                    BotEvent bKey, evBnlsConnect
                    Me.BNLSStart
                Case sBattleNet
                    If ProxyInit Then
                        BotEvent bKey, evProxyConnect
                        ProxyStart
                    Else
                        BotEvent bKey, evConnect
                        Me.BNetStart
                    End If
                Case sMCP
                    BotEvent bKey, evRealmConnect
                    MCPStart
            End Select
        Case sData
            Select Case SocketType
                Case sBNLS
                    Me.BNLSData Data, Length
                Case sBattleNet
                    If ProxyInit Then
                        ProxyData Data, Length
                    Else
                        Me.BNetData Data, Length
                    End If
                Case sMCP
                    MCPData Data, Length
            End Select
        Case sDisconnect
            Select Case SocketType
                Case sBNLS
                    BotEvent bKey, evBnlsDisconnect
                    BNLS.onDisconnect
                Case sBattleNet
                    TalkOK = False
                    BotEvent bKey, evDisconnect
                    S.onDisconnect
                Case sMCP
                    BotEvent bKey, evRealmDisconnect
                    MCP.onDisconnect
            End Select
    End Select
End Sub

Public Sub ProxyStart()
    Dim P As New Packet
    Select Case ProxyType
        Case socks4
            With P
                .InsertByte 4
                .InsertByte 1
                .InsertWORD htons(6112)
                .InsertDWORD GetHostByNameAlias(Server)
                .InsertString ProxyUser
                S.Send .GetData(), , True
            End With
        Case socks5
            With P
                .InsertByte 5
                If Len(ProxyUser) Then
                    .InsertByte 2
                    .InsertByte 0
                    .InsertByte 2
                Else
                    .InsertByte 1
                    .InsertByte 0
                End If
                S.Send .GetData(), , True
            End With
    End Select
End Sub

Public Sub ProxyData(Data As String, Length As Long)
    Dim P As New Packet, O As New Packet, bWk As Byte
    P.SetData Data
    Select Case ProxyType
        Case socks4
            With P
                .Skip 1
                bWk = .GetByte()
                Select Case bWk
                    Case 90
                        BotEvent bKey, evSuccess, "SOCKS4 request granted."
                        ProxyInit = False
                        SocketEvent sConnect, sBattleNet
                    Case 91
                        BotEvent bKey, evConError, "SOCKS4 request rejected or failed."
                        ProxyInit = False
                    Case 92
                        BotEvent bKey, evConError, "SOCKS4 request rejected; server requires identd."
                        ProxyInit = False
                    Case 93
                        BotEvent bKey, evConError, "SOCKS4 request rejected; user ID and identd are different."
                        ProxyInit = False
                End Select
            End With
        Case socks5
            Select Case PCStage
                Case 0
                    'Handshake response
                    P.Skip 1
                    bWk = P.GetByte()
                    Select Case bWk
                        Case 0
                            PCStage = 2
                            With O
                                .InsertByte 5
                                .InsertByte 1
                                .InsertByte 0
                                .InsertByte 1
                                .InsertDWORD GetHostByNameAlias(Server)
                                .InsertWORD htons(6112)
                                S.Send .GetData(), , True
                            End With
                        Case 2
                            If Len(ProxyUser) > 255 Or Len(ProxyPassword) > 255 Then
                                BotEvent bKey, evConError, "Could not connect: Your SOCKS5 username and password must be 255 characters or less in length."
                                S.Disconnect
                                Exit Sub
                            End If
                            PCStage = 1
                            With O
                                .InsertByte 1
                                .InsertByte Len(ProxyUser)
                                .InsertNonNTString ProxyUser
                                .InsertByte Len(ProxyPassword)
                                .InsertNonNTString ProxyPassword
                                S.Send .GetData(), , True
                            End With
                        Case &HFF
                            BotEvent bKey, evConError, "SOCKS5: Server did not accept authentication."
                            ProxyInit = False
                    End Select
                Case 1
                    'Login response
                    P.Skip 1
                    bWk = P.GetByte()
                    If bWk = 0 Then
                        BotEvent bKey, evSuccess, "SOCKS5: Username and password accepted."
                        PCStage = 2
                        With O
                            .InsertByte 5
                            .InsertByte 1
                            .InsertByte 0
                            .InsertByte 1
                            .InsertDWORD GetHostByNameAlias(Server)
                            .InsertWORD htons(6112)
                            S.Send .GetData(), , True
                        End With
                    Else
                        BotEvent bKey, evConError, "SOCKS5: Username and password rejected."
                        ProxyInit = False
                    End If
                Case 2
                    'Connect response
                    P.Skip 1
                    bWk = P.GetByte()
                    Select Case bWk
                        Case &H0
                            ProxyInit = False
                            SocketEvent sConnect, sBattleNet
                        Case &H1
                            BotEvent bKey, evConError, "SOCKS5: Server failure."
                            ProxyInit = False
                        Case &H2
                            BotEvent bKey, evConError, "SOCKS5: Connection not allowed."
                            ProxyInit = False
                        Case &H3
                            BotEvent bKey, evConError, "SOCKS5: Proxy server could not contact Battle.Net."
                            ProxyInit = False
                        Case &H4
                            BotEvent bKey, evConError, "SOCKS5: Proxy server could not contact Battle.Net."
                            ProxyInit = False
                        Case &H5
                            BotEvent bKey, evConError, "SOCKS5: Battle.Net refused the proxy server's attempt to connect."
                            ProxyInit = False
                        Case &H6
                            BotEvent bKey, evConError, "SOCKS5: Time-to-live expired."
                            ProxyInit = False
                        Case &H7
                            BotEvent bKey, evConError, "SOCKS5: Proxy server does not support connections."
                            ProxyInit = False
                        Case &H8
                            BotEvent bKey, evConError, "SOCKS5: Proxy server cannot handle IPv4 addresses."
                            ProxyInit = False
                        Case Else
                            BotEvent bKey, evConError, "SOCKS5: Unknown connection status response."
                            S.Disconnect
                            ProxyInit = False
                    End Select
            End Select
    End Select
End Sub

Public Sub BNLSStart()
    BotEvent bKey, evConMsg, "Sending BNLS authorization..."
    Dim P As New Packet
    P.InsertString "cloakedchat"
    BNLS.Send P.GetData, BNLS_AUTHORIZE
End Sub

Public Sub BNLSData(Data As String, Length As Long)
    Dim Size As Integer, PacketID As Byte, P As New Packet, O As New Packet, lngWork&, _
        bWork As Byte, i&
    P.SetData Data
    While Size < Length And i < 1024
        Size = Size + P.GetWORD()
        PacketID = P.GetByte()
        'Debug.Print "Recieved BNLS packet " & PacketID
        Select Case PacketID
            Case BNLS_AUTHORIZE
                lngWork = P.GetDWORD()
                O.InsertDWORD BNLSChecksum("k56Y8xSsDed5swl2Hoj6", lngWork)
                BNLS.Send O.GetData(), BNLS_AUTHORIZEPROOF
            Case BNLS_AUTHORIZEPROOF
                BotEvent bKey, evConMsg, "Authorized with BNLS."
                O.InsertDWORD GetBNLSProduct()
                BNLS.Send O.GetData(), BNLS_REQUESTVERSIONBYTE
            Case BNLS_REQUESTVERSIONBYTE
                P.Skip 4
                VerByte = P.GetDWORD()
                'MsgBox "About to connect to Battle.net", vbExclamation, "BnetBot"
                ConnectToBattleNet
                'TestCDKeyEx
            Case BNLS_CDKEY_EX
                P.Skip 4
                bWork = P.GetByte()
                P.Skip 1
                'BotEvent bKey, evConMsg, "Recieved " + CStr(P.GetByte()) + " / " + CStr(bWork) + _
                    " CD keys."
                lngWork = P.GetDWORD()
                If (Client = bpDiablo2x) Then
                    If lngWork = 2 Then
                        BotEvent bKey, evConError, "BNLS could not decode your Diablo II original CD-Key."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    ElseIf lngWork = 1 Then
                        BotEvent bKey, evConError, "BNLS could not decode your Lord of Destruction CD-Key."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    ElseIf lngWork = 0 Then
                        BotEvent bKey, evConError, "BNLS could not decode your Diablo II or Lord of Destruction CD-Keys."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    End If
                ElseIf (Client = bpWarCraft3x) Then
                    If lngWork = 2 Then
                        BotEvent bKey, evConError, "BNLS could not decode your WarCraft III original CD-Key."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    ElseIf lngWork = 1 Then
                        BotEvent bKey, evConError, "BNLS could not decode your WC3: The Frozen Throne CD-Key."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    ElseIf lngWork = 0 Then
                        BotEvent bKey, evConError, "BNLS could not decode your WarCraft III or Frozen Throne CD-Keys."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    End If
                Else
                    If lngWork = 0 Then
                        BotEvent bKey, evConError, "BNLS could not decode your CD-Key."
                        closesocket BNLS.Sock
                        closesocket S.Sock
                        Exit Sub
                    End If
                End If
                'BotEvent bKey, evDbg, Data
                With P
                    ClientSession = .GetDWORD()
                    CDKeyData = .GetFixedString(36)
                    If Client = bpDiablo2x Or Client = bpWarCraft3x Then
                        .Skip 4
                        ExCDKeyData = .GetFixedString(36)
                    End If
                End With
                If Verbose Then
                    If bWork = 1 Then
                        BotEvent bKey, evSuccess, "CD-Key encrypted successfully."
                    ElseIf bWork = 2 Then
                        BotEvent bKey, evSuccess, "CD-Keys encrypted successfully."
                    End If
                End If
                With O
                    .InsertDWORD GetBNLSProduct()
                    Select Case IX86File
                        Case "IX86ver0.mpq":
                            .InsertDWORD &H0
                        Case "IX86ver1.mpq":
                            .InsertDWORD &H1
                        Case "IX86ver2.mpq":
                            .InsertDWORD &H2
                        Case "IX86ver3.mpq":
                            .InsertDWORD &H3
                        Case "IX86ver4.mpq":
                            .InsertDWORD &H4
                        Case "IX86ver5.mpq":
                            .InsertDWORD &H5
                        Case "IX86ver6.mpq":
                            .InsertDWORD &H6
                        Case "IX86ver7.mpq":
                            .InsertDWORD &H7
                    End Select
                    'BotEvent bKey, evDbg, ChecksumFormula
                    .InsertString ChecksumFormula
                    BNLS.Send O.GetData(), BNLS_VERSIONCHECK
                End With
            Case BNLS_VERSIONCHECK
                'BotEvent bKey, evConMsg, "Recieved BNLS_VERSIONCHECK."
                'BotEvent bKey, evDbg, StrToHex(Data)
                If (P.GetBoolean() = False) Then
                    Disconnect
                    BotEvent bKey, evConError, "Version check failed."
                    Exit Sub
                End If
                If Verbose Then _
                    BotEvent bKey, evSuccess, "Version check succeeded."
                With O
                    'BotEvent bKey, evDbg, ClientSession
                    .InsertDWORD ClientSession 'Client session key
                    .InsertDWORD P.GetDWORD 'Version
                    .InsertDWORD P.GetDWORD 'Checksum
                    If (Client = bpDiablo2x Or Client = bpWarCraft3x) Then
                        .InsertDWORD &H2 '2 keys
                    Else
                        .InsertDWORD &H1 '1 key
                    End If
                    .InsertDWORD 0
                    .InsertNonNTString CDKeyData
                    If (Client = bpDiablo2x Or Client = bpWarCraft3x) Then _
                        .InsertNonNTString ExCDKeyData
                    .InsertString P.GetString 'Statstring
                    If LenB(Register) = 0 Then
                        .InsertString DEFAULT_REGISTER 'Register (Default)
                    Else
                        .InsertString Register 'Register
                    End If
                    S.Send .GetData, SID_AUTH_CHECK
                End With
            Case BNLS_HASHDATA
                If Verbose Then _
                    BotEvent bKey, evConMsg, "Recieved password hash."
                With O
                    If CreatingAccount = False Then
                        PasswordHash = P.GetFixedString(20)
                        .InsertDWORD ClientSession
                        .InsertDWORD ServerSession
                        .InsertNonNTString PasswordHash 'Hash Data
                        .InsertNTString Username
                        S.Send .GetData(), SID_LOGONRESPONSE2
                    Else
                        .InsertNonNTString P.GetFixedString(20)
                        .InsertString Username
                        S.Send .GetData(), SID_CREATEACCOUNT2
                        CreatingAccount = False
                    End If
                End With
            Case BNLS_LOGONCHALLENGE
                With O
                    .InsertNonNTString P.GetFixedString(32)
                    .InsertString Username
                    S.Send .GetData(), SID_AUTH_ACCOUNTLOGON
                End With
            Case BNLS_LOGONPROOF
                With O
                    .InsertNonNTString P.GetFixedString(20)
                    S.Send .GetData(), SID_AUTH_ACCOUNTLOGONPROOF
                End With
            Case BNLS_CONFIRMLOGON
                If P.GetBoolean = False Then
                    BotEvent bKey, evConError, "Unable to confirm that Battle.Net server knows your password!"
                    Disconnect
                    Exit Sub
                End If
                If RegRequired Then
                    'E-Mail Registration
                    BotEvent bKey, evRegisterEmail, , Username
                Else
                    EnterChat
                End If
            Case BNLS_CREATEACCOUNT
                BotEvent bKey, evConMsg, "Recieved BNLS_CREATEACCOUNT."
                With O
                    .InsertNonNTString P.GetFixedString(64)
                    .InsertString Username
                    S.Send .GetData(), SID_AUTH_ACCOUNTCREATE
                End With
        End Select
        If P.Position < Size Then _
            P.Skip Size - P.Position + 1
        i = i + 1
    Wend
End Sub

Public Sub BNetStart()
    Dim P As New Packet
    SendData S.Sock, Chr$(1)
    If Verbose Then _
        BotEvent bKey, evConMsg, "Sent protocol byte."
    With P
        .InsertDWORD &H0 'Protocol ID (always zero)
        .InsertNonNTString "68XI" 'Platform ID (Intel x86)
        .InsertNonNTString StrReverse(ClientKeyToStr(Client)) 'Game Client
        .InsertDWORD VerByte 'Version byte
        .InsertDWORD &H0 'Product Language
        .InsertDWORD &H0 'Local IP for Network Address Translation
        .InsertDWORD &H0 'Time zone bias
        .InsertDWORD &H0 'Locale ID
        .InsertDWORD &H0 'Language ID
        .InsertString "USA" 'Country abbreviation
        .InsertString "United States" 'Country
    End With
    S.Send P.GetData(), SID_AUTH_INFO
End Sub

Public Sub BNetData(Data As String, Length As Long)
On Error GoTo BND_Error
    Dim PacketID As Byte, P As Packet, O As Packet, i&, pEnd&, lngWork&, eID&
    Dim strTmp$, eFlags&, ePing&, eUser$, eMsg$, tmpUser As New User, bytTmp As Byte
    Dim j&, cWork As Collection, lngWork2&
    Set P = New Packet
    Set O = New Packet
    
    'Fragmented packet handling
    If BNOL > 0 Then
        Length = Length + BNOL
        Data = BNOD & Data
        BNOD = ""
        BNOL = 0
    End If
    
    P.SetData Data
    While P.Position < Length
        On Error GoTo BND_Error
        With P
            If .GetByte() <> &HFF Then
                BotEvent bKey, evConError, "Received invalid packet from Battle.Net."
                BNOD = ""
                BNOL = 0
                Exit Sub
            End If
            PacketID = .GetByte()
            pEnd = P.Position + .GetWORD() - 2
            '-2 because we already read the StartPacket Byte and the Packet ID
        End With
        
        Select Case PacketID
            Case SID_PING
                O.InsertDWORD P.GetDWORD()
                S.Send O.GetData(), SID_PING
            Case SID_AUTH_INFO
                'BotEvent bKey, evConMsg, "Recieved SID_AUTH_INFO."
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0:
                        UseNLS = False
                        BotEvent bKey, evConMsg, "Using Old Logon System (Broken SHA-1)."
                    Case &H1:
                        UseNLS = True
                        BotEvent bKey, evConMsg, "Using New Logon System Version 1."
                    Case &H2:
                        UseNLS = True
                        BotEvent bKey, evConMsg, "Using New Login System Version 2."
                        O.InsertDWORD &H2
                        BNLS.Send O.GetData(), BNLS_CHOOSENLSREVISION
                    Case Else:
                        BotEvent bKey, evConError, "Unrecognised logon type.  You should check if a new version of Myriad is available."
                        closesocket S.Sock
                        If UseBNLS Then closesocket BNLS.Sock
                        Exit Sub
                End Select
                If UseBNLS Then
                    With O
                        If Verbose Then _
                            BotEvent bKey, evConMsg, "Requesting CD-key hash..."
                        .InsertDWORD &H0 'Cookie (yummy!)
                        
                        'Number of CD-Keys:
                        If (Client = bpDiablo2x Or Client = bpWarCraft3x) Then
                            .InsertByte &H2 'Original + Expansion Keys
                        Else
                            .InsertByte &H1 'Original Key Only
                        End If
                        .InsertDWORD &H1 'Same session key flag
                        ServerSession = P.GetDWORD() 'Server key
                        .InsertDWORD ServerSession
                        .InsertNTString CDKey 'Original key
                        If (Client = bpDiablo2x Or Client = bpWarCraft3x) Then _
                            .InsertNTString ExCDKey 'Expansion key
                        'MsgBox "Sending BNLS_CDKEY_EX", vbExclamation, "BnetBot"
                    End With
                    BNLS.Send O.GetData, BNLS_CDKEY_EX
                    With P
                        .Skip 12
                        IX86File = .GetString
                        ChecksumFormula = .GetString
                    End With
                Else
                    With P
                        ServerSession = .GetDWORD()
                        .Skip 12
                        IX86File = .GetString()
                        ChecksumFormula = .GetString()
                    End With
                    'Hashed
                    SendAuthCheck
                End If
            Case SID_AUTH_CHECK
                lngWork = P.GetDWORD()
                
                Select Case lngWork
                    Case &H0
                        BotEvent bKey, evSuccess, "Passed version and CD-Key check."
                    Case &H100
                        Disconnect
                        BotEvent bKey, evConError, "Game version is out of date.  Wait for a BNLS update."
                        Exit Sub
                    Case &H101
                        Disconnect
                        BotEvent bKey, evConError, "Invalid game version."
                        Exit Sub
                    Case &H200
                        Disconnect
                        BotEvent bKey, evConError, "Invalid CD-Key."
                        Exit Sub
                    Case &H201
                        Disconnect
                        strTmp = P.GetString
                        If LenB(strTmp) > 0 Then
                            BotEvent bKey, evConError, "CD-Key in use by " & strTmp & "."
                        Else
                            BotEvent bKey, evConError, "CD-Key in use."
                        End If
                        Exit Sub
                    Case &H202
                        Disconnect
                        BotEvent bKey, evConError, "CD-Key is banned from Battle.Net."
                        Exit Sub
                    Case &H203
                        Disconnect
                        BotEvent bKey, evConError, "CD-Key is for another game."
                        Exit Sub
                    Case &H210
                        Disconnect
                        BotEvent bKey, evConError, "Invalid Expansion CD-Key."
                        Exit Sub
                    Case &H211
                        Disconnect
                        strTmp = P.GetString
                        If LenB(strTmp) > 0 Then
                            BotEvent bKey, evConError, "Expansion CD-Key in use by " & strTmp & "."
                        Else
                            BotEvent bKey, evConError, "Expansion CD-Key in use."
                        End If
                        Exit Sub
                    Case &H212
                        Disconnect
                        BotEvent bKey, evConError, "Expansion CD-Key is banned from Battle.Net."
                        Exit Sub
                    Case &H213
                        Disconnect
                        BotEvent bKey, evConError, "Expansion CD-Key is for another game."
                        Exit Sub
                End Select
                With O
                    If UseNLS Then
                        .InsertString Username
                        .InsertString LCase$(Password)
                        BNLS.Send .GetData(), BNLS_LOGONCHALLENGE
                    Else
                        If UseBNLS Then
                            .InsertDWORD Len(Password) 'Length of password
                            .InsertDWORD &H2 'Double-hash flag
                            .InsertNonNTString LCase$(Password)
                            .InsertDWORD ClientSession
                            .InsertDWORD ServerSession
                            BNLS.Send .GetData(), BNLS_HASHDATA
                        Else
                            'PasswordHash = String$(28, vbNullChar)
                            'If (PasswordHashEx(PasswordHash, ClientSession, ServerSession, _
                                Password)) Then
                            '    AddC StrToHex(PasswordHash)
                            '    AddC LngToHex(ClientSession)
                            '    AddC LngToHex(ServerSession)
                            '    AddC StrToHex(Mid$(PasswordHash, 9))
                            PasswordHash = HashPassword(LCase$(Password), ClientSession, ServerSession)
                            If (LenB(PasswordHash)) Then
                                .InsertDWORD ClientSession
                                .InsertDWORD ServerSession
                                .InsertNonNTString PasswordHash
                                .InsertString Username
                                S.Send .GetData(), SID_LOGONRESPONSE2
                            Else
                                BotEvent bKey, evConError, "Failed to hash your password."
                                Disconnect
                                Exit Sub
                            End If
                        End If
                    End If
                End With
            Case SID_AUTH_ACCOUNTLOGON
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0
                        With O
                            .InsertNonNTString P.GetFixedString(64)
                            BNLS.Send .GetData(), BNLS_LOGONPROOF
                        End With
                    Case &H1
                        BotEvent bKey, evConError, "Account does not exist."
                        If (MsgBox("The account you have attempted to connect with does not exist.  Would you like to create it?", _
                            vbQuestion Or vbYesNo, GetVersion(mvTitlebar)) = vbYes) Then
                            With O
                                .InsertString Username
                                .InsertString LCase$(Password)
                                BNLS.Send O.GetData(), BNLS_CREATEACCOUNT
                            End With
                        End If
                    Case &H5
                        BotEvent bKey, evConMsg, "Account requires upgrade."
                    Case Else
                        BotEvent bKey, evConError, "Unknown failure on SID_AUTH_ACCOUNTLOGON."
                        Disconnect
                End Select
            Case SID_AUTH_ACCOUNTLOGONPROOF
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0
                        'Success
                        RegRequired = False
                        BotEvent bKey, evSuccess, "Username and password accepted."
                        With O
                            .InsertNonNTString P.GetFixedString(20)
                            BNLS.Send .GetData(), BNLS_CONFIRMLOGON
                        End With
                    Case &H2
                        BotEvent bKey, evConError, "Your password is incorrect."
                        Disconnect
                    Case &HE
                        'E-Mail Registration Needed
                        RegRequired = True
                        BotEvent bKey, evSuccess, "Username and password accepted."
                        With O
                            .InsertNonNTString P.GetFixedString(20)
                            BNLS.Send .GetData(), BNLS_CONFIRMLOGON
                        End With
                    Case Else
                        BotEvent bKey, evConError, "Unknown failure on SID_AUTH_ACCOUNTLOGONPROOF."
                        Disconnect
                End Select
            Case SID_AUTH_ACCOUNTCREATE
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0
                        BotEvent bKey, evSuccess, "Account created."
                        With O
                            .InsertString Username
                            .InsertString LCase$(Password)
                            BNLS.Send .GetData(), BNLS_LOGONCHALLENGE
                        End With
                        Exit Sub
                    Case &H7
                        BotEvent bKey, evConError, "Username is too short."
                        Disconnect
                    Case &H8
                        BotEvent bKey, evConError, "Username contains an illegal character."
                        Disconnect
                    Case &H9
                        BotEvent bKey, evConError, "Username contains an illegal word."
                        Disconnect
                    Case &HA
                        BotEvent bKey, evConError, "Username contains too few alphanumeric characters."
                        Disconnect
                    Case &HB
                        BotEvent bKey, evConError, "Username contains punctuation characters that are next to each other."
                        Disconnect
                    Case &HC
                        BotEvent bKey, evConError, "Username contains too many punctuation characters."
                        Disconnect
                    Case Else
                        BotEvent bKey, evConError, "Unknown account creation error."
                        Disconnect
                End Select
            Case SID_LOGONRESPONSE2
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0
                        BotEvent bKey, evSuccess, "Username and password accepted."
                        If UseRealm Then
                            S.Send "", SID_REALMINIT
                        Else
                            EnterChat
                        End If
                    Case &H1
                        BotEvent bKey, evConError, "Account does not exist."
                        If (MsgBox("The account you have attempted to connect with does not exist.  Would you like to create it?", _
                            vbQuestion Or vbYesNo, GetVersion(mvTitlebar)) = vbYes) Then
                            If UseBNLS Then
                                CreatingAccount = True
                                With O
                                    .InsertDWORD Len(Password) 'Length of password
                                    .InsertDWORD &H0
                                    .InsertNonNTString LCase$(Password)
                                    BNLS.Send .GetData(), BNLS_HASHDATA
                                End With
                            Else
                                strTmp = String$(20, vbNullChar)
                                CalcHashBuf strTmp, LCase$(Password), Len(Password)
                                With O
                                    .InsertNonNTString strTmp
                                    .InsertString Username
                                    S.Send .GetData(), SID_CREATEACCOUNT2
                                End With
                            End If
                        End If
                    Case &H2
                        BotEvent bKey, evConError, "Invalid or incorrect password."
                        Disconnect
                End Select
            Case SID_REALMINIT
                If Len(Realm) = 0 Then
                    With P
                        .Skip 12
                        Realm = .GetString()
                    End With
                End If
                'strTmp = String$(20, vbNullChar)
                'Call GetPasswordHash(strTmp, ServerSession, "password")
                'CalcHashBuf ByVal strTmp, ByVal "password", 8
                'AddC StrToHex(strTmp), vbWhite
                'CalcHashBuf ByVal strTmp, ByVal MakeDWORD(ClientSession) & _
                    MakeDWORD(ServerSession) & strTmp, 28
                'AddC StrToHex(strTmp), vbWhite
                strTmp = RealmPassword()
                With O
                    .InsertDWORD ClientSession
                    .InsertNonNTString strTmp
                    .InsertString Realm
                    S.Send .GetData(), SID_LOGONREALMEX
                End With
            Case SID_LOGONREALMEX
                Dim MCPIP As Long, MCPPort As Integer
                With P
                    .Skip 4
                    lngWork = .GetDWORD()
                    Select Case lngWork
                        Case &H80000001
                            AddC "Realm is currently unavailable.", vbRed
                            EnterChat
                            Exit Sub
                        Case &H80000002
                            AddC "Realm password was rejected.", vbRed
                            EnterChat
                            Exit Sub
                    End Select
                    .Skip -8
                    AddC Len(MCPChunk)
                    MCPChunk = .GetFixedString(16)
                    MCPIP = .GetDWORD()
                    MCPPort = PackPort(.GetDWORD())
                    AddC Len(MCPChunk)
                    MCPChunk = MCPChunk & .GetFixedString(48)
                    AddC Len(MCPChunk)
                    AddC StrToHex(MCPChunk)
                    RUniqueUsername = .GetString()
                    ConnectToRealm MCPIP, MCPPort
                End With
            Case SID_CREATEACCOUNT2
                CreatingAccount = False
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case 0:
                        BotEvent bKey, evSuccess, "Account created."
                        With O
                            .InsertDWORD ClientSession
                            .InsertDWORD ServerSession
                            .InsertNonNTString PasswordHash 'Hash Data
                            .InsertNTString Username
                            S.Send .GetData(), SID_LOGONRESPONSE2
                        End With
                        'Hash password (yeah, again) to be used in logging in.
                        'With O
                        '    .InsertDWORD Len(Password) 'Length of password
                        '    .InsertDWORD &H0
                        '    .InsertNonNTString LCase$(Password)
                        '    BNLS.Send .GetData(), BNLS_HASHDATA
                        'End With
                    Case 1, 6:
                        BotEvent bKey, evConError, "The username " & Username & " is too short."
                        Disconnect
                    Case 2:
                        BotEvent bKey, evConError, "The username " & Username & " contains invalid characters."
                        Disconnect
                    Case 3:
                        BotEvent bKey, evConError, "The username " & Username & " contains a banned word."
                        Disconnect
                    Case 4:
                        BotEvent bKey, evConError, "The username " & Username & " already exists."
                        Disconnect
                    Case Else:
                        BotEvent bKey, evConError, "Unknown result code on account creation."
                        Disconnect
                End Select
            Case SID_ENTERCHAT
                RealUsername = P.GetString()
                BotEvent bKey, evConMsg, "Logged on as " & RealUsername & "."
                'If LenB(Home) = 0 Then Home = "Public Chat Myriad"
                'With O
                '    .InsertDWORD &H0
                '    .InsertString Home
                '    S.Send .GetData(), SID_JOINCHANNEL
                'End With
            Case SID_CHATEVENT
                With P
                    eID = .GetDWORD()
                    eFlags = .GetDWORD()
                    ePing = .GetDWORD()
                    .Skip 12
                    eUser = .GetString()
                    eMsg = .GetString()
                End With
                Select Case eID
                    Case EID_TALK
                        'If CollectionHasKey(SpamUsers, eUser) = False And _
                            GetTickCount() - ChannelUsers(eUser).JoinTime > 100 Then
                                BotEvent bKey, evTalk, eMsg, eUser, eFlags, ePing
                        'Else
                        '    AddC "!", vbWhite
                        '    SpamUsers.Add eUser, eUser
                        '    ChannelUsers.Remove eUser
                        '    NotifyUserMove bKey, eID
                        'End If
                    Case EID_SHOWUSER
                        'If CollectionHasKey(SpamUsers, eUser) Then Exit Sub
                        UsersInChannel = UsersInChannel + 1
                        'AddC "EID_SHOWUSER: " & eUser
                        CUAdd eUser, ClientStrToKey(StrReverse(Left$(eMsg, 4))), _
                            eFlags, ePing
                        UpdateLocation bKey, Channel, UsersInChannel
                        NotifyUserMove bKey, EID_SHOWUSER
                        'AddC "Adding " & eUser
                        BotEvent bKey, evUser, StrReverse(Left$(eMsg, 4)), _
                            eUser, eFlags, ePing
                    Case EID_JOIN
                        'AddC GetTickCount() - ChannelUsers(eUser).JoinTime & "ms", vbWhite
                        'If CollectionHasKey(SpamUsers, eUser) Then Exit Sub
                        UsersInChannel = UsersInChannel + 1
                        CUAdd eUser, ClientStrToKey(StrReverse(Left$(eMsg, 4))), _
                            eFlags, ePing
                        UpdateLocation bKey, Channel, UsersInChannel
                        NotifyUserMove bKey, EID_JOIN
                        BotEvent bKey, evJoin, StrReverse(Left$(eMsg, 4)), _
                            eUser, eFlags, ePing
                    Case EID_USERFLAGS
                        'AddC "Recieved flag update for " & eUser & ".", vbWhite
                        'If CollectionHasKey(SpamUsers, eUser) Then Exit Sub
                        If CUExists(eUser) Then
                            ChannelUsers(eUser).Flags = eFlags
                            If eFlags And USER_CHANNELOP Then
                                ChannelUsers(eUser).IsOperator = True
                            Else
                                ChannelUsers(eUser).IsOperator = False
                            End If
                        Else
                            CUAdd eUser, ClientStrToKey(StrReverse(Left$(eMsg, 4))), _
                            eFlags, ePing
                        End If
                        NotifyUserMove bKey, EID_USERFLAGS
                        BotEvent bKey, evUserFlags, StrReverse(Left$(eMsg, 4)), _
                            eUser, eFlags, ePing
                    Case EID_LEAVE
                        'AddC GetTickCount() - ChannelUsers(eUser).JoinTime & "ms", vbWhite
                        'If CollectionHasKey(SpamUsers, eUser) Then Exit Sub
                        'If GetTickCount() - ChannelUsers(eUser).JoinTime <= 100 Then
                        '    AddC "!", vbWhite
                        '    SpamUsers.Add eUser, eUser
                        '    ChannelUsers.Remove eUser
                        '    NotifyUserMove bKey, eID
                        '    Exit Sub
                        'End If
                        ChannelUsers.Remove eUser
                        UsersInChannel = UsersInChannel - 1
                        BotEvent bKey, evPart, , eUser
                        NotifyUserMove bKey, EID_LEAVE
                    Case EID_CHANNEL
                        Channel = eMsg
                        If Channel = "The Void" Then Talk "/unsquelch " & RealUsername
                        Set ChannelUsers = New Collection
                        UsersInChannel = 0
                        If HasJoinedChannel Then
                            BotEvent bKey, evJoinedChannel, eMsg, , eFlags, 0
                        Else
                            HasJoinedChannel = True
                            BotEvent bKey, evJoinedChannel, eMsg, , eFlags, 1
                        End If
                        UpdateLocation bKey, eMsg, 0
                    Case EID_EMOTE
                        'AddC GetTickCount() - ChannelUsers(eUser).JoinTime & "ms", vbWhite
                        'If CollectionHasKey(SpamUsers, eUser) = False And _
                            GetTickCount() - ChannelUsers(eUser).JoinTime > 100 Then
                                BotEvent bKey, evEmote, eMsg, eUser, eFlags
                        'Else
                        '    AddC "!", vbWhite
                        '    SpamUsers.Add eUser, eUser
                        '    ChannelUsers.Remove eUser
                        '    NotifyUserMove bKey, eID
                        'End If
                    Case EID_INFO
                        BotEvent bKey, evInfo, eMsg
                    Case EID_ERROR
                        BotEvent bKey, evError, eMsg
                    Case EID_WHISPER
                        BotEvent bKey, evWhisperRecv, eMsg, eUser
                    Case EID_WHISPERSENT
                        BotEvent bKey, evWhisperSend, eMsg, eUser
                    Case EID_BROADCAST
                        BotEvent bKey, evBroadcast, eMsg, eUser
                End Select
            Case SID_MESSAGEBOX
                With P
                    lngWork = .GetDWORD()
                    MsgBox .GetString(), lngWork, .GetString()
                End With
            Case SID_READUSERDATA
                If RequestingStats Then
                    'BotEvent bKey, evConMsg, "Recieved account stastics."
                    RequestingStats = False
                    Dim ftTmp As Filetime, stTmp As SystemTime
                    With P
                        'BotEvent bKey, evDbg, StrToHex(Data)
                        lngWork = .GetDWORD()
                        lngWork = .GetDWORD()
                        lngWork = .GetDWORD()
                        'BotEvent bKey, evDbg, lngWork
                        'strTmp = .GetString()
                        'strTmp = .GetString() 'Account created
                        'BotEvent bKey, evConMsg, strTmp
                        'ftTmp = StringToFiletime(strTmp)
                        'CopyMemory ftTmp, ByVal strTmp, 8
                        FileTimeToSystemTime StringToFiletime(.GetString()), stTmp
                        BotEvent bKey, evInfo, "Account Created: " & _
                            ProcessSystemTime(stTmp)
                        'strTmp = .GetString() 'Last login
                        'ftTmp = StringToFiletime(strTmp)
                        'CopyMemory ftTmp, ByVal strTmp, 8
                        FileTimeToSystemTime StringToFiletime(.GetString()), stTmp
                        BotEvent bKey, evInfo, "Last Logged In: " & _
                            ProcessSystemTime(stTmp)
                        'strTmp = .GetString() 'Last logout
                        'ftTmp = StringToFiletime(strTmp)
                        'CopyMemory ftTmp, ByVal strTmp, 8
                        FileTimeToSystemTime StringToFiletime(.GetString()), stTmp
                        BotEvent bKey, evInfo, "Last Logged Out: " & _
                            ProcessSystemTime(stTmp)
                        'strTmp = .GetString() 'Time logged
                        BotEvent bKey, evInfo, "Time Logged: " & _
                            ProcessInterval(.GetString())
                    End With
                Else
                    With P
                        .Skip 4
                        lngWork = .GetDWORD()
                        lngWork2 = .GetDWORD()
                    End With
                    With PendingProfileRequests(lngWork2)
                        ProfileReceived bKey, .User, .Keys, P.GetStringArray(lngWork)
                    End With
                End If
            Case SID_CLANINFO
                With P
                    .Skip 1
                    strTmp = .GetString()
                    BotEvent bKey, evInfo, ClanInfo(strTmp, .GetByte())
                End With
            Case SID_FINDCLANCANDIDATES
                With P
                    .Skip 4
                    FCStatus = .GetByte()
                    bytTmp = .GetByte()
                    ClanCandidates = .GetStringArray(bytTmp)
                End With
                GotCandidates = True
            Case SID_INVITEMULTIPLEUSERS
                ClanCreateSuccess = True
            Case SID_AUTH_REGISTEREMAIL
                BotEvent bKey, evRegisterEmail, , Username
            Case SID_CLANINVITE
                With P
                    lngWork2 = .GetDWORD()
                    lngWork = .GetDWORD()
                    strTmp = String$(4, Chr$(0))
                    CopyMemory ByVal strTmp, lngWork, 4
                    strTmp = StrReverse(Replace(strTmp, vbNullChar, ""))
                    InvitedToClan bKey, lngWork2, lngWork, strTmp, .GetString(), .GetString()
                End With
            Case SID_GETADVLISTEX
                'On Error GoTo BND_Error
                'lngWork = P.GetDWORD()
                'AddC "Got game list! " & lngWork & " games.", vbWhite
                'If lngWork > 0 Then
                '    Dim dgl As New frmGameList
                '    For j = 1 To lngWork
                '        With P
                '            Set cWork = New Collection
                '            cWork.Add .GetWORD(), "type"
                '            .Skip 8
                '            cWork.Add .GetWORD(), "port"
                '            cWork.Add IPToString(.GetDWORD()), "ip"
                '            .Skip 16
                '            cWork.Add UTF8Decode(.GetString()), "name"
                '            'AddC cWork("name"), vbWhite
                '            'AddC cWork("ip"), vbWhite
                '            'AddC cWork("port"), vbWhite
                '            'AddC cWork("type"), vbWhite
                '            dgl.AddGame cWork("name"), .GetString(), cWork("type"), _
                '                cWork("ip"), cWork("port")
                '            strTmp = .GetString()
                '            Set cWork = Nothing
                '        End With
                '    Next j
                '    dgl.Show
                'End If
            Case SID_NULL
            Case &H4A
            Case Else
                Dim PIS As String * 1
                CopyMemory ByVal PIS, PacketID, 1
                BotEvent bKey, evInfo, "Recieved unhandled packet 0x" & LTrim$(StrToHex(PIS)) & ".  " & StrToHex(Data)
        End Select
        
        If P.Position < pEnd Then
            'AddC "Skipping to " & pEnd & " from " & P.Position
            'AddC StrToHex(Mid$(Data, P.Position, pEnd - P.Position + 4)), vbWhite
            P.Skip pEnd - P.Position
        End If
    Wend
    Exit Sub
BND_Error:
    If Err.Number = 20000 Then
        BotEvent bKey, evDbg, "Trying to read beyond end of packet; assuming packet was fragmented."
        BNOD = Data
        BNOL = Length
    Else
        BotEvent bKey, evConError, "[BNet PP] " & Err.Description & " (#" & Err.Number & ")"
    End If
End Sub

Public Function CUExists(ByVal User As String) As Boolean
On Error GoTo CUE_Error
    Dim tU As User
    Set tU = ChannelUsers(User)
    CUExists = True
    Set tU = Nothing
    Exit Function
CUE_Error:
    CUExists = False
End Function

Public Sub RequestProfile(ByVal Username As String, Keys() As String)
On Error Resume Next
    Dim rKey&, P As Packet, i&
    rKey = UBound(PendingProfileRequests) + 1
    If Err.Number = 9 Then
        rKey = 0
        ReDim PendingProfileRequests(0) As RequestInfo
    Else
        ReDim Preserve PendingProfileRequests(rKey) As RequestInfo
    End If
    With PendingProfileRequests(rKey)
        .Keys = Keys
        .User = Username
    End With
On Error GoTo RP_Error
    Set P = New Packet
    
    With P
        .InsertDWORD 1
        'AddC "Requesting: " & ((UBound(Keys) - LBound(Keys)) + 1) & " keys."
        .InsertDWORD (UBound(Keys) - LBound(Keys)) + 1
        .InsertDWORD rKey
        .InsertString Username
        .InsertStringArray Keys
        S.Send .GetData(), SID_READUSERDATA
    End With
RP_Error:
    On Error GoTo 0
End Sub

Public Sub WriteProfile(Keys() As String, Values() As String)
    Dim P As Packet
    Set P = New Packet
    
    With P
        .InsertDWORD 1
        .InsertDWORD (UBound(Keys) - LBound(Keys)) + 1
        .InsertString Username
        .InsertStringArray Keys
        .InsertStringArray Values
        S.Send .GetData(), SID_WRITEUSERDATA
    End With
End Sub

Public Function HashPassword(ByVal Password$, ByVal ClientToken As Long, _
    ByVal ServerToken As Long)
    Dim FirstPass As String, SecondPass As String, FinalPass As String, _
    CTS As String * 4, STS As String * 4
    
    FirstPass = String$(20, vbNullChar)
    CalcHashBuf ByVal FirstPass, ByVal Password, Len(Password)
    CopyMemory ByVal CTS, ClientToken, 4
    CopyMemory ByVal STS, ServerToken, 4
    SecondPass = CTS & STS & FirstPass
    FinalPass = String$(20, vbNullChar)
    CalcHashBuf ByVal FinalPass, ByVal SecondPass, 28
    HashPassword = FinalPass
End Function

Public Sub SendAuthCheck()
    'Hashed connections only.
    Dim P As Packet
    ClientSession = GetTickCount()
    CDKeyData = String$(36, vbNullChar)
    If (CDKeyHashEx(CDKeyData, CDKey, ClientSession, ServerSession)) Then
        'AddC StrToHex(CDKeyData), vbWhite
        If Client = bpDiablo2x Then
            ExCDKeyData = String$(36, vbNullChar)
            If (CDKeyHashEx(ExCDKeyData, ExCDKey, ClientSession, ServerSession)) Then
            Else
                BotEvent bKey, evConError, "Failed to hash your Lord of Destruction CD-key."
                Disconnect
                Exit Sub
            End If
        End If
    Else
        BotEvent bKey, evConError, "Failed to hash your CD-key."
        Disconnect
        Exit Sub
    End If
    
    Dim Version&, Checksum&, EXEInfo$
    EXEInfo = String$(255, Chr$(0))
    If (CheckVersion(Hash1, Hash2, Hash3, ChecksumFormula, _
        Version, Checksum, EXEInfo, IX86File)) Then
        NullTruncateString EXEInfo
        Set P = New Packet
        With P
            .InsertDWORD ClientSession 'Client session key
            .InsertDWORD Version
            .InsertDWORD Checksum
            If (Client = bpDiablo2x) Then
                .InsertDWORD &H2 '2 keys
            Else
                .InsertDWORD &H1 '1 key
            End If
            .InsertDWORD 0 'Spawn
            .InsertNonNTString CDKeyData
            If (Client = bpDiablo2x) Then _
                .InsertNonNTString ExCDKeyData
            .InsertString EXEInfo 'Statstring
            If LenB(Register) = 0 Then
                .InsertString DEFAULT_REGISTER 'Register (Default)
            Else
                .InsertString Register 'Register
            End If
            S.Send .GetData(), SID_AUTH_CHECK
        End With
    Else
        BotEvent bKey, evConError, "Failed to get hashes of the ""hash files""."
        Disconnect
    End If
End Sub

Private Sub NullTruncateString(nString As String)
    Dim i&
    i = InStr(nString, vbNullChar)
    If i = 0 Then Exit Sub
    
    nString = Left$(nString, i - 1)
End Sub

Public Sub CDKeyHashTest()
    Dim OB As String
    OB = String$(44, vbNullChar)
    AddC CDKeyHashEx(OB, CDKey, ClientSession, ServerSession), vbWhite
    AddC StrToHex(OB), vbWhite
End Sub

Private Function RealmPassword(Optional ByVal rPassword As String = "password")
    Dim strTmp As String * 20, strTmp2 As String * 20
    CalcHashBuf ByVal strTmp, ByVal rPassword, Len(rPassword)
    CalcHashBuf ByVal strTmp2, ByVal MakeDWORD(ClientSession) & _
        MakeDWORD(ServerSession) & strTmp, 28
    RealmPassword = strTmp2
    'strTmp = String$(20, vbNullChar)
    'Call GetPasswordHash(strTmp, ServerSession, "password")
    'CalcHashBuf ByVal strTmp, ByVal "password", 8
    'AddC StrToHex(strTmp), vbWhite
    'CalcHashBuf ByVal strTmp, ByVal MakeDWORD(ClientSession) & _
        MakeDWORD(ServerSession) & strTmp, 28
    'AddC StrToHex(strTmp), vbWhite
End Function

Private Function PackPort(Port As Long) As Integer
    Dim intWork As Integer
    intWork = 0
    CopyMemory intWork, Port, 2
    PackPort = intWork
End Function

Private Function MakeDWORD(Data As Long) As String
    Dim Result As String * 4
    CopyMemory ByVal Result, Data, 4
    MakeDWORD = Result
End Function

Private Function ConnectToRealm(Server As Long, Port As Integer) As Boolean
    Set MCP = New Arbiter
    Dim tR%
    ConnectToRealm = False
    tR = frmMain.txtRecv.Count
    Load frmMain.txtRecv(tR)
    If MCP.Initialize(frmMain.txtRecv(tR).hWnd, bKey, sMCP) Then
        BotEvent bKey, evRealmConnecting, Server
        If MCP.ConnectRaw(Server, Port) = False Then
            BotEvent bKey, evConError, "Could not connect to the realm."
            EnterChat
        Else
            ConnectToRealm = True
        End If
    Else
        BotEvent bKey, evConError, "Could not initialize MCP (realm) socket."
        EnterChat
    End If
End Function

Private Sub MCPStart()
    Dim P As New Packet
    With P
        .InsertNonNTString MCPChunk
        .InsertString RUniqueUsername
        MCP.Send .GetData(), MCP_STARTUP
    End With
End Sub

Private Sub MCPData(Data As String, Length As Long)
    Dim P As New Packet, O As New Packet, pLen&, Pos&, PacketID As Byte, lngWork&
    P.SetData Data
    While (Pos < Length)
        With P
            pLen = .GetWORD()
            PacketID = .GetByte()
        End With
        Select Case PacketID
            Case MCP_STARTUP
                lngWork = P.GetDWORD()
                Select Case lngWork
                    Case &H0
                        BotEvent bKey, evRealmStarted
                    Case &HC
                        BotEvent bKey, evRealmStartFailure, "The realm could not find your Battle.Net connection."
                        EnterChat
                    Case Else
                        BotEvent bKey, evRealmStartFailure, "Unknown realm startup failure."
                        EnterChat
                End Select
        End Select
        
        With P
            If .Position < pLen Then _
                .Skip pLen - .Position + 1
            Pos = Pos + .Position
        End With
    Wend
End Sub

Private Function UTF8Encode(str As String) As String
    Dim InputChars As Long
    InputChars = Len(str)
   
    'We need to first convert the ASCII input to Unicode before we can convert it to UTF-8...
    Dim UnicodeChars As Long, UnicodeBuffer As String
    UnicodeChars = MultiByteToWideChar(CP_ACP, 0, str, InputChars, vbNullString, 0)
    UnicodeBuffer = Space(UnicodeChars * 2)
    MultiByteToWideChar CP_ACP, 0, str, InputChars, UnicodeBuffer, UnicodeChars
   
    'Now that we've got everything translated to Unicode, we can (finally) convert it to UTF-8.
    Dim UTF8Chars As Long, UTF8Buffer As String
    UTF8Chars = WideCharToMultiByte(CP_UTF8, 0, UnicodeBuffer, UnicodeChars, 0, 0, vbNullString, 0)
    UTF8Buffer = Space(UTF8Chars)
    WideCharToMultiByte CP_UTF8, 0, UnicodeBuffer, UnicodeChars, UTF8Buffer, UTF8Chars, vbNullString, 0
   
    UTF8Encode = UTF8Buffer
End Function

Private Function UTF8Decode(str As String) As String
    Dim InputBytes As Long
    InputBytes = Len(str)
   
    'Again, we need to convert the UTF-8 string to Unicode before we can convert it to 8-bit.
    Dim UnicodeChars As Long, UnicodeBuffer As String
    UnicodeChars = MultiByteToWideChar(CP_UTF8, 0, str, InputBytes, vbNullString, 0)
    UnicodeBuffer = Space(UnicodeChars * 2)
    MultiByteToWideChar CP_UTF8, 0, str, InputBytes, UnicodeBuffer, UnicodeChars
   
    'Now that we've got everything translated to Unicode, we can convert it to 8-bit characters.
    Dim SingleByteChars As Long, SingleByteBuffer As String
    SingleByteChars = WideCharToMultiByte(CP_ACP, 0, UnicodeBuffer, UnicodeChars, vbNullString, 0, vbNullString, 0)
    SingleByteBuffer = Space(SingleByteChars)
    WideCharToMultiByte CP_ACP, 0, UnicodeBuffer, UnicodeChars, SingleByteBuffer, SingleByteChars, vbNullString, 0
   
    UTF8Decode = SingleByteBuffer
End Function

Public Sub RequestGameList()
    If Client <> bpStarCraft And Client <> bpBroodWar Then Exit Sub
    Dim P As New Packet
    With P
        .InsertWORD 0
        .InsertWORD 0
        .InsertDWORD 48
        .InsertDWORD 0
        .InsertDWORD 25
        .InsertByte 0
        .InsertByte 0
        .InsertByte 0
        S.Send .GetData(), SID_GETADVLISTEX
    End With
End Sub

Public Sub BinaryRejoin()
    If TalkOK Then
        Dim P As New Packet
        With P
            S.Send "", &H10
            .InsertDWORD 2
            .InsertString Channel
            S.Send .GetData(), SID_JOINCHANNEL
        End With
    End If
End Sub

Public Sub ClanInviteAccepted(Cookie&, ClanTag&, Inviter$)
    Dim P As New Packet
    With P
        .InsertDWORD Cookie
        .InsertDWORD ClanTag
        .InsertString Inviter
        .InsertByte &H6
        S.Send .GetData(), SID_CLANINVITE
    End With
End Sub

Public Sub ClanInviteDeclined(Cookie&, ClanTag&, Inviter$)
    Dim P As New Packet
    With P
        .InsertDWORD Cookie
        .InsertDWORD ClanTag
        .InsertString Inviter
        .InsertByte &H4
        S.Send .GetData(), SID_CLANINVITE
    End With
End Sub

Public Function FindClanCandidates(ClanTag As String) As Boolean
    Dim O As New Packet, L&, RT As String * 4
    L = Len(ClanTag)
    Select Case L
        Case 1: RT = vbNullChar & vbNullChar & vbNullChar & ClanTag
        Case 2: RT = vbNullChar & vbNullChar & StrReverse(ClanTag)
        Case 3: RT = vbNullChar & StrReverse(ClanTag)
        Case 4: RT = StrReverse(ClanTag)
        Case Else
            FindClanCandidates = False
            Exit Function
    End Select
    With O
        .InsertDWORD Rand(1, 128000)
        .InsertNonNTString RT
        S.Send .GetData(), SID_FINDCLANCANDIDATES
    End With
    FindClanCandidates = True
End Function

Public Function GetClanCandidates() As String()
    GetClanCandidates = ClanCandidates
End Function

Public Function CreateClan(ClanTag As String, ClanName As String, InitialMembers() As String, _
    NumberOfMembers As Byte) As Boolean
    ClanCreateSuccess = False
    If Len(ClanName) < 1 Then
        CreateClan = False
        Exit Function
    End If
    
    Dim P As New Packet, L&, RT As String * 4
    L = Len(ClanTag)
    Select Case L
        Case 1: RT = vbNullChar & vbNullChar & vbNullChar & ClanTag
        Case 2: RT = vbNullChar & vbNullChar & StrReverse(ClanTag)
        Case 3: RT = vbNullChar & StrReverse(ClanTag)
        Case 4: RT = StrReverse(ClanTag)
        Case Else
            CreateClan = False
            Exit Function
    End Select
    With P
        .InsertDWORD Rand(1, 64000)
        .InsertString ClanName
        .InsertNonNTString RT
        .InsertByte NumberOfMembers
        .InsertStringArray InitialMembers
        S.Send .GetData(), SID_INVITEMULTIPLEUSERS
    End With
    CreateClan = True
End Function

Private Function ClanInfo(ClanName As String, Rank As Byte, Optional User As String = "") As String
    If LenB(User) = 0 Then
        ClanInfo = "You are "
    Else
        ClanInfo = User & " is "
    End If
    Select Case Rank
        Case RANK_NEW_PEON: ClanInfo = ClanInfo & "a new peon in"
        Case RANK_PEON: ClanInfo = ClanInfo & "a peon in"
        Case RANK_GRUNT: ClanInfo = ClanInfo & "a grunt in"
        Case RANK_SHAMAN: ClanInfo = ClanInfo & "a shaman in"
        Case RANK_CHIEFTAIN: ClanInfo = ClanInfo & "the chieftain of"
    End Select
    ClanInfo = ClanInfo & " Clan " & StrReverse(ClanName) & "."
End Function

Private Function StringToFiletime(T As String) As Filetime
    Dim Frag() As String, FT As Filetime
    'BotEvent bKey, evDbg, "StringToFiletime(""" & T & """)"
    Frag = Split(T, " ")
    If Val(Frag(0)) < 2 ^ 31 Then
        FT.dwHighDateTime = Val(Frag(0))
    Else
        FT.dwHighDateTime = Val(Frag(0)) - 2 ^ 32
    End If
    If UBound(Frag) > 0 Then
        If Val(Frag(1)) < 2 ^ 31 Then
            FT.dwLowDateTime = Val(Frag(1))
        Else
            FT.dwLowDateTime = Val(Frag(1)) - 2 ^ 32
        End If
    End If
    StringToFiletime = FT
End Function

Private Function ProcessInterval(T As String) As String
On Error Resume Next
    Dim lngSeconds As Long, lngDays As Long, lngHours As Long, lngMins As Long
    'Dim strSeconds As String, strDays As String, strHours As String, strMinutes As String, _
    strXSeconds As String, strXMinutes As String, strXHours As String
    lngSeconds = T
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds Mod 86400
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds Mod 3600
    lngMins = Int(lngSeconds / 60)
    lngSeconds = lngSeconds Mod 60
    If lngDays = 1 Then
        ProcessInterval = "1 day, "
    ElseIf lngDays > 1 Then
        ProcessInterval = lngDays & " days, "
    End If
    If lngHours = 1 Then
        ProcessInterval = ProcessInterval & "1 hour, "
    ElseIf lngHours > 1 Then
        ProcessInterval = ProcessInterval & lngHours & " hours, "
    ElseIf lngHours = 0 And lngDays >= 1 Then
        ProcessInterval = ProcessInterval & "0 hours, "
    End If
    If lngMins = 1 Then
        ProcessInterval = ProcessInterval & "1 minute, "
    ElseIf lngMins > 1 Then
        ProcessInterval = ProcessInterval & lngMins & " minutes, "
    ElseIf lngMins = 0 And lngHours >= 1 Then
        ProcessInterval = ProcessInterval & "0 minutes, "
    End If
    If lngSeconds = 1 Then
        ProcessInterval = ProcessInterval & "1 second"
    ElseIf lngSeconds > 1 Then
        ProcessInterval = ProcessInterval & lngSeconds & " seconds"
    ElseIf lngSeconds = 0 And lngDays >= 1 Then
        ProcessInterval = ProcessInterval & "0 seconds"
    End If
        
    'If lngDays <> 1 Then strDays = "s"
    'If lngHours < 10 Then strXHours = "0"
    'If lngMins < 10 Then strXMinutes = "0"
    'If lngSeconds < 10 Then strXSeconds = "0"
    'ProcessInterval = lngDays & " day" & strDays & ", " & strXHours & lngHours & ":" _
    & strXMinutes & lngMins & ":" & strXSeconds & lngSeconds
End Function

Private Function ProcessSystemTime(T As SystemTime) As String
    Select Case T.wDayOfWeek
        Case 0: ProcessSystemTime = "Sunday, "
        Case 1: ProcessSystemTime = "Monday, "
        Case 2: ProcessSystemTime = "Tuesday, "
        Case 3: ProcessSystemTime = "Wednesday, "
        Case 4: ProcessSystemTime = "Thursday, "
        Case 5: ProcessSystemTime = "Friday, "
        Case 6: ProcessSystemTime = "Saturday, "
    End Select
    Select Case T.wMonth
        Case 1: ProcessSystemTime = ProcessSystemTime & "January"
        Case 2: ProcessSystemTime = ProcessSystemTime & "February"
        Case 3: ProcessSystemTime = ProcessSystemTime & "March"
        Case 4: ProcessSystemTime = ProcessSystemTime & "April"
        Case 5: ProcessSystemTime = ProcessSystemTime & "May"
        Case 6: ProcessSystemTime = ProcessSystemTime & "June"
        Case 7: ProcessSystemTime = ProcessSystemTime & "July"
        Case 8: ProcessSystemTime = ProcessSystemTime & "August"
        Case 9: ProcessSystemTime = ProcessSystemTime & "September"
        Case 10: ProcessSystemTime = ProcessSystemTime & "October"
        Case 11: ProcessSystemTime = ProcessSystemTime & "November"
        Case 12: ProcessSystemTime = ProcessSystemTime & "December"
    End Select
    ProcessSystemTime = ProcessSystemTime & " " & T.wDay & ", " & T.wYear & " "
    Dim ap$
    If T.wHour > 12 Then
        T.wHour = T.wHour - 12
        ap = "PM"
    ElseIf T.wHour = 0 Then
        T.wHour = 12
        ap = "AM"
    Else
        ap = "AM"
    End If
    ProcessSystemTime = ProcessSystemTime & T.wHour & ":"
    If T.wMinute < 10 Then ProcessSystemTime = ProcessSystemTime & "0"
    ProcessSystemTime = ProcessSystemTime & T.wMinute & ":"
    If T.wSecond < 10 Then ProcessSystemTime = ProcessSystemTime & "0"
    ProcessSystemTime = ProcessSystemTime & T.wSecond & " " & ap
End Function

Public Sub CUAdd(ByVal Username As String, Client As bnProduct, _
    Flags As Long, Ping As Long)
On Error Resume Next
    Dim tmpUser As New User
    With tmpUser
        .Username = Username
        .Product = Client
        .Flags = Flags
        .Ping = Ping
        If Flags And USER_CHANNELOP Then
            .IsOperator = True
        Else
            .IsOperator = False
        End If
        .JoinTime = GetTickCount()
    End With
    'If tmpUser.IsOperator Then
    '    AddC "Adding channel user: " & Username & " [op]."
    'Else
    '    AddC "Adding channel user: " & Username
    'End If
    ChannelUsers.Add tmpUser, Username
End Sub

Public Function GetChanUserInfo(ByVal Username$, Client As bnProduct, Flags&, Ping&) As Boolean
On Error GoTo CUI_Err
    With ChannelUsers(Username)
        Client = .Product
        Flags = .Flags
        Ping = .Ping
    End With
    GetChanUserInfo = True
    Exit Function
CUI_Err:
    GetChanUserInfo = False
End Function

Public Sub ChannelListDump()
    Dim i&
    For i = 1 To ChannelUsers.Count()
        If ChannelUsers(i).IsOperator Then
            AddC i & ": " & ChannelUsers(i).Username & " (op) " & ClientKeyToName(ChannelUsers(i).Product)
        Else
            AddC i & ": " & ChannelUsers(i).Username & " " & ClientKeyToName(ChannelUsers(i).Product)
        End If
    Next i
End Sub

'worthless piece of shit (6-12-2004)
'Public Sub BuildChannelList()
'    Dim i&, FirstPass As Boolean, Count&
'    FirstPass = True
'    Count = ChannelUsers.Count()
'    i = 1
'    While i <= Count
'        If FirstPass = True And ChannelUsers(i).IsOperator Then
'            BotEvent bKey, evBuildList, ClientKeyToStr(ChannelUsers(i).Product), _
'                ChannelUsers(i).Username, ChannelUsers(i).Flags, ChannelUsers(i).Ping
'        ElseIf FirstPass = False And ChannelUsers(i).IsOperator = False Then
'            BotEvent bKey, evBuildList, ClientKeyToStr(ChannelUsers(i).Product), _
'                ChannelUsers(i).Username, ChannelUsers(i).Flags, ChannelUsers(i).Ping
'        End If
'        If FirstPass And i = Count Then
'            FirstPass = False
'            i = 1
'        Else
'            i = i + 1
'        End If
'    Wend
'    UpdateLocation bKey, Channel, UsersInChannel
'End Sub

'Public Sub BuildChannelList()
'    'AddC "BnetBot.BuildChannelList()", vbWhite
'    'chList.ListItems.Clear
'    'Exit Sub
'    Dim i&, j&, Count&, FirstPass As Boolean
'    j = 1
'    Count = ChannelUsers.Count()
'    If Count = 0 Then
'        Exit Sub
'    End If
'    FirstPass = True
'
'    'For i = 1 To Count
'    '    AddC i & ": " & ChannelUsers(i).Username
'    'Next i
'
'    For i = 1 To Count
'        If FirstPass = True And (ChannelUsers(i).Flags And USER_CHANNELOP) Then
'            'AddC "Adding op: " & ChannelUsers(i).Username
'            BotEvent bKey, evBuildList, ClientKeyToStr(ChannelUsers(i).Product), _
'                ChannelUsers(i).Username, ChannelUsers(i).Flags, ChannelUsers(i).Ping
'        ElseIf FirstPass = False And (ChannelUsers(i).Flags And USER_CHANNELOP) = 0 Then
'            'AddC "Adding normal user: " & ChannelUsers(i).Username
'            BotEvent bKey, evBuildList, ClientKeyToStr(ChannelUsers(i).Product), _
'                ChannelUsers(i).Username, ChannelUsers(i).Flags, ChannelUsers(i).Ping
'        End If
'        If i = Count And FirstPass Then
'            i = 0
'            FirstPass = False
'        End If
'    Next i
'    UpdateLocation bKey, Channel, UsersInChannel
'End Sub

Public Function MoreUsers() As Boolean
    If UserI <= ChannelUsers.Count() Then
        MoreUsers = True
    Else
        MoreUsers = False
    End If
End Function

Public Function NextUser(Optional Client As bnProduct, Optional Ping As Long, Optional Flags As Long, Optional IsOp As Boolean)
    NextUser = ChannelUsers(UserI).Username
    If IsMissing(Client) = False Then Client = ChannelUsers(UserI).Product
    If IsMissing(Flags) = False Then Flags = ChannelUsers(UserI).Flags
    If IsMissing(Ping) = False Then Ping = ChannelUsers(UserI).Ping
    If IsMissing(IsOp) = False Then IsOp = ChannelUsers(UserI).IsOperator
    UserI = UserI + 1
End Function

Public Sub ResetUserI()
    UserI = 1
End Sub

Public Sub EnterChat()
On Error Resume Next
    Dim O As New Packet
    'We won't be needing BNLS anymore...
    If UseBNLS Then _
        BNLS.Disconnect
    With O
        .InsertNonNTString "tenb"
        S.Send O.GetData(), SID_UDPPINGRESPONSE
        .InsertString Username
        .InsertString ""
        S.Send O.GetData(), SID_ENTERCHAT
        BotEvent bKey, evConMsg, "Joining home channel " & Home & "..."
        If LenB(Home) = 0 Then Home = "Public Chat Myriad"
        .InsertDWORD &H2
        .InsertString Home
        JoiningChannel = True
        JoinTarget = Home
        S.Send .GetData(), SID_JOINCHANNEL
        TalkOK = True
    End With
End Sub

Public Sub RequestStats()
    RequestingStats = True
    BotEvent bKey, evConMsg, "Requesting account statistics..."
    Dim P As Packet
    Set P = New Packet
    With P
        .InsertDWORD 1 '1 acct
        .InsertDWORD 4 '4 fields
        .InsertDWORD 5468
        .InsertString Username
        .InsertString "System\Account Created"
        .InsertString "System\Last Logon"
        .InsertString "System\Last Logoff"
        .InsertString "System\Time Logged"
        S.Send .GetData(), SID_READUSERDATA
    End With
End Sub

Public Function BNetSend(Data As String, Optional PacketID As Byte) As Boolean
    If IsMissing(PacketID) Then
        BNetSend = S.Send(Data)
    Else
        BNetSend = S.Send(Data, PacketID)
    End If
End Function

Public Sub Talk(Text As String)
    Call Say(Text)
End Sub

Public Sub Say(Text As String)
    If Not TalkOK Then Exit Sub
    Dim P As New Packet
    LastTick = GetTickCount()
    With P
        .InsertString Text
        S.Send P.GetData(), SID_CHATCOMMAND
    End With
    BotEvent bKey, evSelfTalk, Text
End Sub

Private Function ConnectToBattleNet() As Boolean
Dim tR As Integer
    ConnectToBattleNet = False
    If UseBNLS = False Then
        VerByte = GetVersionByte(Client)
        If VerByte = 0 Then
            BotEvent bKey, evConError, "The version byte for " & ClientKeyToName(Client) & " is unavailable."
            Exit Function
        End If
    End If
    
    If Proxy Then
        ProxyInit = True
        BotEvent bKey, evProxyConnecting
        Dim P As New Packet
        If ProxyType = socks4 Or ProxyType = socks5 Then
            If LenB(ProxyServer) = 0 Then
                BotEvent bKey, evConError, "Could not connect to proxy server.  No proxy server was specified."
                Exit Function
            End If
            tR = frmMain.txtRecv.Count
            Load frmMain.txtRecv(tR)
            If S.Initialize(frmMain.txtRecv(tR).hWnd, bKey, sBattleNet) Then
                If S.Connect(ProxyServer, ProxyPort) = False Then
                    BotEvent bKey, evConError, "Could not connect to the proxy server."
                Else
                    ConnectToBattleNet = True
                End If
            End If
        End If
    Else
        If LenB(Server) = 0 Then
            BotEvent bKey, evConError, "Could not connect to Battle.Net because no server was specified."
            Exit Function
        End If
        tR = frmMain.txtRecv.Count
        Load frmMain.txtRecv(tR)
        If S.Initialize(frmMain.txtRecv(tR).hWnd, bKey, sBattleNet) Then
            BotEvent bKey, evConnecting, Server
            If S.Connect(Server, 6112) = False Then
                BotEvent bKey, evConError, "Could not connect to Battle.Net."
            Else
                ConnectToBattleNet = True
            End If
        Else
            BotEvent bKey, evConError, "Could not initialize Battle.Net socket."
        End If
    End If
End Function

Public Function GetSock() As Long
    GetSock = S.Sock
End Function

Public Function GetSocket(sType As mSocketType) As Long
On Error Resume Next
    Select Case sType
        Case sBattleNet: GetSocket = S.Sock
        Case sBNLS: GetSocket = BNLS.Sock
        Case sMCP: GetSocket = MCP.Sock
    End Select
End Function

Public Function GetBNLSSock() As Long
On Error Resume Next
    GetBNLSSock = BNLS.Sock
End Function

'Private Sub InitCRC32()
'    Dim i As Long, j As Long, K As Long, XorVal As Long
'
'    Static CRC32Initialized As Boolean
'    If CRC32Initialized Then Exit Sub
'    CRC32Initialized = True
'
'    For i = 0 To 255
'        K = i
'
'        For j = 1 To 8
'            If K And 1 Then XorVal = CRC32_POLYNOMIAL Else XorVal = 0
'            If K < 0 Then K = ((K And &H7FFFFFFF) \ 2) Or &H40000000 Else K = K \ 2
'            K = K Xor XorVal
'        Next
'
'        CRC32Table(i) = K
'    Next
'End Sub

'Private Function CRC32(ByVal Data As String) As Long
'    Dim i As Long, j As Long
'
'    Call InitCRC32
'
'    CRC32 = &HFFFFFFFF
'
'    For i = 1 To Len(Data)
'        j = CByte(Asc(Mid(Data, i, 1))) Xor (CRC32 And &HFF&)
'        If CRC32 < 0 Then CRC32 = ((CRC32 And &H7FFFFFFF) \ &H100&) Or &H800000 Else CRC32 = CRC32 \ &H100&
'        CRC32 = CRC32 Xor CRC32Table(j)
'    Next
'
'    CRC32 = Not CRC32
'End Function

'Private Function BNLSChecksum(ByVal Password As String, ByVal ServerCode As Long) As Long
'    BNLSChecksum = CRC32(Password & Right("0000000" & Hex(ServerCode), 8))
'End Function

Private Function GetBNLSProduct() As Long
    Select Case Client
        Case bpStarCraft: GetBNLSProduct = PRODUCT_STARCRAFT
        Case bpBroodWar: GetBNLSProduct = PRODUCT_BROODWAR
        Case bpDiablo2: GetBNLSProduct = PRODUCT_DIABLO2
        Case bpDiablo2x: GetBNLSProduct = PRODUCT_LORDOFDESTRUCTION
        Case bpWarCraft2: GetBNLSProduct = PRODUCT_WAR2BNE
        Case bpWarCraft3: GetBNLSProduct = PRODUCT_WARCRAFT3
        Case bpWarCraft3x: GetBNLSProduct = PRODUCT_THEFROZENTHRONE
    End Select
End Function

Public Sub UICInfo()
    Dim i&
    For i = 1 To ChannelUsers.Count()
        AddC i & ": " & ChannelUsers(i).Username & " using " & ClientKeyToName(ChannelUsers(i).Product) & " with ping of " & ChannelUsers(i).Ping, vbWhite
    Next i
End Sub

Public Function ResendLastBNLS() As Boolean
    ResendLastBNLS = BNLS.ResendLast()
End Function

Private Sub Class_Terminate()
On Error Resume Next
   closesocket S.Sock
   closesocket BNLS.Sock
End Sub

Public Sub TimerTick(ByVal dwTime&)
    If TalkOK And dwTime - LastNullSent >= 15000 Then
        LastNullSent = dwTime
        SendNull
    End If
    If MsgQueue.Count() > 0 And dwTime >= RequiredDelay(Len(MsgQueue(1)), dwTime) Then
        Say MsgQueue(1)
        MsgQueue.Remove 1
    End If
End Sub

Public Sub SendNull()
    Call S.Send("", SID_NULL)
End Sub

'-----------------------------------------------------------------------------------
'  Hashed Connections
'-----------------------------------------------------------------------------------
Public Function SupportsHashedClient(checkClient As bnProduct) As Boolean
    Select Case checkClient
        Case bpStarCraft, bpBroodWar, bpDiablo2, bpDiablo2x, bpWarCraft2
            SupportsHashedClient = True
        Case Else
            SupportsHashedClient = False
    End Select
End Function

Public Function GetVersionByte(Product As bnProduct) As Long
    Select Case Product
        Case bpStarCraft, bpBroodWar: GetVersionByte = &HC9
        Case bpWarCraft2: GetVersionByte = &H4F
        Case bpDiablo2, bpDiablo2x: GetVersionByte = &HA
    End Select
    'GetVersionByte = CLng("&H" & GetSetting("VerByte", ClientKeyToStr(Product)))
End Function


'-----------------------------------------------------------------------------------
'  Queue
'-----------------------------------------------------------------------------------

Public Sub qAdd(ByVal Message As String, Optional ByVal Urgent As Boolean = False)
    If Urgent And MsgQueue.Count() > 0 Then
        MsgQueue.Add Message, , 1
    Else
        MsgQueue.Add Message
    End If
End Sub

Private Function RequiredDelay(ByVal Bytes As Long, Optional ByVal Tick As Long = 0) As Long
    Static SentBytes As Long
    Const PerPacket = 200
    Const PerByte = 10
    Const MaxBytes = 600
    If Tick = 0 Then _
        Tick = GetTickCount()
    If (LastTick - Tick) > (SentBytes * PerByte) Then
        SentBytes = 0
    Else
        SentBytes = SentBytes - (LastTick - Tick) / PerByte
    End If
    If (SentBytes + PerPacket + Bytes) > MaxBytes Then
        RequiredDelay = Tick + (SentBytes + PerPacket + Bytes - MaxBytes) * PerByte
    Else
        SentBytes = SentBytes + PerPacket + Bytes
        RequiredDelay = Tick
    End If
End Function

