Attribute VB_Name = "Commands"
Option Explicit

'----------------------------------------------------------
'  Major`Bot
'  Commands Module
'----------------------------------------------------------
'  Version 1.0.0 (2004-05-20)
'  1.0.0: Module started. (Cloaked)
'----------------------------------------------------------

Public Const ACCESS_SAFELIST = 1
Public Const ACCESS_SHITLIST = 2
Public Const ACCESS_LOCKED = 4
Public Const ACCESS_TRACKED = 8

Private Users As Collection, IterI As Long, cDBFile As String
Public Trigger As String, Master As String, GetWHCT As Long

Private Declare Function GetWinVersionString Lib "myriad.dll" (ByVal Outbuf As String) As Long
'Private Declare Function GetWinVersion Lib "myriad.dll" () As MWVINFO

Public Function GetOSVersionString() As String
    Dim os As String, R&
    os = String$(300, vbNullChar)
    R = GetWinVersionString(os)
    NullTruncateString os
    GetOSVersionString = RTrim$(os)
End Function

Public Sub NullTruncateString(nString As String)
    Dim i&
    i = InStr(nString, Chr$(0))
    If i = 0 Then Exit Sub
    
    nString = Left$(nString, i - 1)
End Sub

Public Function StrToFlags(flags As String) As Long
    Dim i&
    StrToFlags = 0
    For i = 1 To Len(flags)
        Select Case Mid$(flags, i, 1)
            Case "S": StrToFlags = StrToFlags Or ACCESS_SAFELIST
            Case "Z", "B": StrToFlags = StrToFlags Or ACCESS_SHITLIST
            Case "L": StrToFlags = StrToFlags Or ACCESS_LOCKED
            Case "Z": StrToFlags = StrToFlags Or ACCESS_TRACKED
        End Select
    Next i
End Function

Public Function FlagsToStr(flags As Long) As String
    FlagsToStr = ""
    If flags And ACCESS_SAFELIST Then FlagsToStr = FlagsToStr & "S"
    If flags And ACCESS_SHITLIST Then FlagsToStr = FlagsToStr & "B"
    If flags And ACCESS_LOCKED Then FlagsToStr = FlagsToStr & "L"
    If flags And ACCESS_TRACKED Then FlagsToStr = FlagsToStr & "T"
End Function


Public Sub LoadDatabase(DBFile As String)
    Set Users = New Collection
    Open App.Path & "\" & DBFile For Input As #2
    cDBFile = DBFile
    Dim tS$, tU As DatabaseUser, tF() As String
    Do
        Set tU = New DatabaseUser
        Input #2, tS
        tS = Trim$(tS)
        If LenB(tS) Then
            tF = Split(tS, " ")
            BotEvent "", evDbg, "DBUser " & tF(0)
            If UBound(tF) = 2 Then
                tU.Username = tF(0)
                tU.Access = CLng(Val(tF(1)))
                BotEvent "", evDbg, "Access: " & tU.Access
                tU.flags = StrToFlags(tF(2))
                Users.Add tU, LCase$(tF(0))
            ElseIf UBound(tF) = 1 Then
                tU.Username = tF(0)
                tU.Access = CLng(Val(tF(1)))
                BotEvent "", evDbg, "Access: " & tU.Access
                Users.Add tU, LCase$(tF(0))
            End If
        End If
    Loop Until EOF(2)
    Close #2
End Sub

Public Sub WriteDatabase(Optional ByVal DBFile As String = "")
    If LenB(DBFile) = 0 Then DBFile = cDBFile
    Open App.Path & "\" & DBFile For Output As #3
    Dim i&
    For i = 1 To Users.Count()
        If Users(i).flags > 0 Then
            Print #3, Users(i).Username & " " & Users(i).Access & " " & FlagsToStr(Users(i).flags)
        Else
            Print #3, Users(i).Username & " " & Users(i).Access
        End If
    Next i
    Close #3
End Sub

Public Sub ClearMemDatabase()
    Set Users = New Collection
End Sub

Public Sub AddUser(ByVal Username As String, ByVal Access As Long, Optional ByVal flags As Long = 0)
    Dim tU As DatabaseUser
    Set tU = New DatabaseUser
    With tU
        .Username = Username
        .Access = Access
        .flags = flags
    End With
    Users.Add tU
End Sub


'----------------------------------------------------------
'  Iterator
'----------------------------------------------------------

Public Function MoreUsers() As Boolean
    MoreUsers = False
    If IterI <= Users.Count() Then MoreUsers = True
End Function

Public Sub NextUser(Username As String, Access As Long, flags As Long)
On Error Resume Next
    With Users(IterI)
        Username = .Username
        Access = .Access
        flags = .flags
    End With
    IterI = IterI + 1
End Sub

Public Sub ResetI()
    IterI = 0
End Sub




Public Function GetUsers() As Collection
    Dim i&, userOut As Collection
    Set userOut = New Collection
    For i = 1 To Users.Count()
        userOut.Add Users(i), Users(i).Username
    Next i
    Set GetUsers = userOut
End Function

Public Function UserExists(ByVal Username$) As Boolean
On Error GoTo UE_Error
    Username = LCase$(Username)
    Dim tU As Long
    tU = Users(Username).flags
    UserExists = True
    Exit Function
UE_Error:
    UserExists = False
End Function

Public Function IsSafelisted(ByVal Username$) As Boolean
On Error GoTo IS_Error
    Username = LCase$(Username)
    Dim tU As DatabaseUser
    IsSafelisted = False
    tU = Users(Username)
    If tU.flags And ACCESS_SAFELIST Then
        IsSafelisted = True
    End If
    Exit Function
IS_Error:
    IsSafelisted = False
End Function

Public Function IsShitlisted(ByVal Username$) As Boolean
On Error GoTo IS_Error
    Username = LCase$(Username)
    Dim tU As DatabaseUser
    IsShitlisted = False
    tU = Users(Username)
    If tU.flags And ACCESS_SHITLIST Then
        IsShitlisted = True
    End If
    Exit Function
IS_Error:
    IsShitlisted = False
End Function

Public Function IsLocked(ByVal Username$) As Boolean
On Error GoTo IL_Error
    Username = LCase$(Username)
    Dim tU As DatabaseUser
    IsLocked = False
    tU = Users(Username)
    If tU.flags And ACCESS_LOCKED Then
        IsLocked = True
    End If
    Exit Function
IL_Error:
    IsLocked = False
End Function

Public Function GetAccess(ByVal Username$) As Long
On Error GoTo GA_Error
    Username = LCase$(Username)
    GetAccess = 0
    GetAccess = Users(Username).Access
    Exit Function
GA_Error:
    GetAccess = 0
End Function

Public Function IsMaster(ByVal Username$) As Boolean
    If StrComp(Master, Username, vbTextCompare) = 0 Then
        IsMaster = True
    Else
        IsMaster = False
    End If
End Function

Public Function GetFlags(ByVal Username$) As Long
On Error GoTo GA_Error
    Username = LCase$(Username)
    GetFlags = 0
    GetFlags = Users(Username).flags
    Exit Function
GA_Error:
    GetFlags = 0
End Function

'ok so now for the real commands
'which reminds me: we'll need a queue sometime =\

Public Function ProcessCommand(ByVal Command$, ByVal Username$) As Boolean
    Dim lngWork& 'temporary holders
    
    'First, check to see if this is a real command by
    'looking for the trigger.
    If Left$(Command, Len(Trigger)) <> Trigger Then
        'Trigger not present.
        ProcessCommand = False 'command not processed
        Select Case Command
            Case "?trigger"
                If GetAccess(Username) >= 20 Then
                    Dim intAltTrig As Integer, strAltTrig As String
                    intAltTrig = Asc(Trigger)
                    If Len(intAltTrig) = 1 Then
                        strAltTrig = "00" & intAltTrig
                    Else
                        strAltTrig = "0" & intAltTrig
                    End If
                    qAdd "My trigger is " & Trigger & " (Alt + " & strAltTrig & ")"
                End If
        End Select
        Exit Function
    End If
    
    'OK, so it's a command.  Remove the trigger from it.
    Command = Mid$(Command, Len(Trigger) + 1)
    
    'Note that all the Len(Trigger) stuff means that
    'you can have triggers longer than one character.
    
    'Divide the command into words for easier processing.
    Dim Words() As String
    Words = Split(Command, " ")

    'Figure out which command we have.
    Select Case Words(0)
        Case "about", "ver", "version"
            'Check for access.
            If GetAccess(Username) >= 20 Then
                'Do stuff with this command.
                'TODO: Replace with queue.
                qAdd GetVersion() & " by Scope"
                
                'Put this after every successful command.
                'The chat window will use this to determine
                'whether the command should be sent off to
                'b.net or if it was a bot command.
                ProcessCommand = True
            End If
        Case "say"
            If UBound(Words) = 0 Then Exit Function
            If GetAccess(Username) >= 40 Then
                If StrComp(Mid$(Command, Len(Trigger) + 4, 1), "/", vbTextCompare) <> 0 Then
                    qAdd Mid$(Command, Len(Trigger) + 4)
                End If
                ProcessCommand = True
            End If
        Case "ban"
            If UBound(Words) = 0 Then Exit Function
            'Words is an array of all the words in the command.
            'It starts with 0, so the first word (ban) is Words(0)
            'Words(1) is the user to ban
            'So GetAccess(Username) > GetAccess(Words(1) will make it
            'only work if the person doing .ban's access is higher
            'than the person he's trying to ban
            'I'll just leave this here
            '    command access check          "I have more access than he does" check
            '  |------------------------|    |----------------------------------------|
            If GetAccess(Username) >= 60 And GetAccess(Username) > GetAccess(Words(1)) And IsSafelisted(Words(1)) = False Then
                qAdd "/ban " & Mid$(Command, Len(Trigger) + 4)
                ProcessCommand = True
            End If
        Case "kick"
            If UBound(Words) = 0 Then Exit Function
            If GetAccess(Username) >= 50 And GetAccess(Username) > GetAccess(Words(1)) And IsSafelisted(Words(1)) = False Then
                qAdd "/kick " & Mid$(Command, Len(Trigger) + 5)
                ProcessCommand = True
            End If
        Case "resign"
            If GetAccess(Username) >= 80 Then
                qAdd "/resign "
                ProcessCommand = True
            End If
        Case "rejoin"
            If GetAccess(Username) >= 80 Then
                Bot.BinaryRejoin
                ProcessCommand = True
            End If
        Case "designate"
            If GetAccess(Username) >= 90 Then
                qAdd "/designate " & Mid$(Command, Len(Trigger) + 10)
                qAdd "I have designated " & Username & "."
                ProcessCommand = True
            End If
        Case "uptime"
            If GetAccess(Username) >= 20 Then
                qAdd "System uptime: " & _
                    ConvertTime(GetTickCount()) & _
                    "; Bot Uptime: " & _
                    ConvertTime(GetTickCount() - startupTime)
            End If
        Case "whois", "find", "a"
            If UBound(Words) = 0 Then Exit Function
            If GetAccess(Username) >= 20 Then
                If UserExists(Words(1)) Then
                    lngWork = GetFlags(Words(1))
                    If lngWork > 0 Then
                        qAdd Words(1) & ": " & GetAccess(Words(1)) & " " & FlagsToStr(lngWork)
                    Else
                        qAdd Words(1) & ": " & GetAccess(Words(1))
                    End If
                Else
                    qAdd Words(1) & " was not found in the database."
                End If
                ProcessCommand = True
            End If
        Case "whoami"
            lngWork = GetAccess(Username)
            If lngWork > 20 Then
                If GetFlags(Username) > 0 Then
                    qAdd "You have access " & lngWork & " and flags " & FlagsToStr(GetFlags(Username)) & "."
                Else
                    qAdd "You have access " & lngWork & " and no flags."
                End If
                ProcessCommand = True
            End If
        Case "flip"
            If GetAccess(Username) > 20 Then
                lngWork = Rand(1, 2)
                If lngWork = 1 Then
                    qAdd "Heads"
                Else
                    qAdd "Tails"
                End If
                ProcessCommand = True
            End If
        Case "unban"
            If UBound(Words) = 0 Then Exit Function
            If GetAccess(Username) >= 60 And IsShitlisted(Words(1)) = False Then
                qAdd "/unban " & Mid$(Command, Len(Trigger) + 6)
                ProcessCommand = True
            End If
        Case "play"
            If WinampVer > 0 And IsMaster(Username) Then
                If UBound(Words) = 0 Then
                    PlaySong
                    ProcessCommand = True
                Else
                    SetPlayListPosition CInt(Val(Words(1)))
                    ProcessCommand = True
                End If
            End If
        Case "vol", "volume", "setvol"
            If UBound(Words) = 0 Then Exit Function
            If IsMaster(Username) Then
                If WinampVer > 0 Then
                    'convert the logical 0-100 scale to
                    'SetVolume's 0-255 scale
                    SetVolume CInt(Words(1)) / 100 * 255
                Else
                    qAdd "Winamp is not loaded."
                End If
            End If
        Case "stop"
            If WinampVer > 0 And IsMaster(Username) Then
                StopSong
                ProcessCommand = True
            End If
        Case "next"
            If WinampVer > 0 And IsMaster(Username) Then
                NextTrack
                ProcessCommand = True
            End If
        Case "back", "prev"
            If WinampVer > 0 And IsMaster(Username) Then
                PreviousTrack
                ProcessCommand = True
            End If
        Case "mp3"
            If UBound(Words) = 0 And WinampVer > 0 And GetAccess(Username) > 20 Then
                qAdd "/me is playing " & GetSong()
                ProcessCommand = True
            ElseIf Words(1) = "load" Then
                If IsMaster(Username) Then
                    LoadWinamp
                    GetWHCT = GetTickCount() + 200
                    qAdd "/me has loaded Winamp."
                    ProcessCommand = True
                End If
            End If
        Case "os"
            If GetAccess(Username) >= 20 Then
                qAdd GetOSVersionString()
                ProcessCommand = True
            End If
        Case "dns"
            If GetAccess(Username) >= 20 And UBound(Words) > 0 Then
                qAdd Words(1) & ": " & DNSLookup(Words(1))
                ProcessCommand = True
            End If
        Case "idle"
            If GetAccess(Username) >= 60 Then
                If UBound(Words) = 0 And Not IsQueueBusy() Then
                    qAdd GenerateIdleMessage()
                Else
                    Select Case Words(1)
                        Case "on"
                            StartIdling
                            qAdd "Turned on anti-idle."
                        Case "off"
                            StopIdling
                            qAdd "Turned off anti-idle."
                        Case "uptime"
                            idleType = idleUptime
                            qAdd "Idle messages will now show the bot and system uptime."
                        Case "custom"
                            If UBound(Words) > 1 Then
                                idleMsg = Mid$(Command, Len(Trigger) + 12)
                                idleType = idleMessage
                                qAdd "Switched to the specified custom idle message."
                            Else
                                idleType = idleMessage
                                qAdd "Switched to the custom idle message."
                            End If
                        Case "version"
                            idleType = idleBot
                            qAdd "Switched to the bot version idle message."
                        Case "mp3"
                            idleType = idleMp3
                            qAdd "Idle messages will now show the current Winamp song."
                        Case "quote", "quotes"
                            idleType = idleQuotes
                            qAdd "Idle messages will now show a random quote."
                        Case Else
                            If IsNumeric(Words(1)) Then
                                If UBound(Words) = 1 Then
                                    idleDelay = 60000 * CLng(Val(Words(1)))
                                    qAdd "Idle delay is now " & Words(1) & " minute(s)."
                                Else
                                    Select Case Words(2)
                                        Case "min", "mins", "minutes", "minute"
                                            idleDelay = 60000 * CLng(Val(Words(1)))
                                            qAdd "Idle delay is now " & Words(1) & " minute(s)."
                                        Case "sec", "secs", "seconds", "second"
                                            idleDelay = 1000 * CLng(Val(Words(1)))
                                            qAdd "Idle delay is now " & Words(1) & " second(s)."
                                        Case Else
                                            qAdd "Unknown time unit """ & Words(2) & """."
                                    End Select
                                End If
                            Else
                                qAdd "Unknown idle command """ & Words(1) & """."
                            End If
                    End Select
                End If
                ProcessCommand = True
            End If
    End Select
End Function

'Public Function ProcessCommand(ByVal Command$, ByVal Username$)
'    If StrComp(Left$(Command, Len(Trigger)), Trigger, vbTextCompare) <> 0 Then
'        ProcessCommand = False
'        Exit Function
'    End If
'
'    Command = Mid$(Command, Len(Trigger) + 1)
'
'    Dim Words() As String
'    Words = Split(Command, " ")
'
'    Select Case Words(0)
'        Case "about", "ver", "version"
'            If GetAccess(Username) >= 20 Then
'                qAdd GetVersion()
'                ProcessCommand = True
'            End If
'    End Select
'End Function
