Attribute VB_Name = "Config"
Option Explicit

'----------------------------------------------------------
'  Major`Bot
'  Configuration Module
'----------------------------------------------------------
'  Version 1.0.1 (2004-05-26)
'  1.0.0: Module created.  It's basically some of Myriad's
'         Config module.
'  1.0.1: Added settings for web channel. (Cloaked)
'----------------------------------------------------------

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function ConfigString(Key$, ByRef Destination$, Optional Category$ = "Main") As Boolean
    Dim strTmp$
    strTmp = GetConfig(Key, Category)
    If LenB(strTmp) Then
        Destination = strTmp
        ConfigString = True
    Else
        ConfigString = False
    End If
End Function

Public Sub ConfigBool(Key$, Destination As Boolean, Optional Category$ = "Main")
    Destination = GetBoolean(Key, Category)
End Sub
    

Function GetConfig(Key$, Optional Category$ = "Main") As String
On Error Resume Next
    GetConfig = GetFromINI("config.ini", Category, Key)
End Function

Function GetBoolean(Key$, Optional Category$ = "Main", Optional Default As Boolean = False) As Boolean
On Error Resume Next
    Dim strTmp$
    strTmp = LCase$(GetFromINI("config.ini", Category, Key))
    Select Case strTmp
        Case "yes", "y", "true", "on", "1", "active", "enabled"
            GetBoolean = True
        Case "no", "n", "false", "off", "0", "inactive", "disabled"
            GetBoolean = False
        Case Else
            GetBoolean = Default
    End Select
End Function

Function WriteConfig(Key$, ByVal strValue$, Optional Category$ = "Main") As Boolean
On Error Resume Next
    WriteConfig = WriteToINI("config.ini", Category, Key, strValue)
End Function

Private Function GetFromINI(INIFile$, Category$, Key$) As String
On Error Resume Next
    Dim sFile$, sDefault$, lSize%, L As Long, sUser$
    sUser = Space$(255)
    lSize = 255
    sFile = App.Path & "\" & INIFile
    sDefault = ""
    L = GetPrivateProfileString(Category, Key, sDefault, sUser, lSize, sFile)
    sUser = RTrim$(sUser)
    GetFromINI = Left$(sUser, Len(sUser) - 1)
End Function

Private Function WriteToINI(INIFile$, Category$, Key$, ByVal strValue$) As Boolean
On Error Resume Next
    Dim sFile$, L As Long
    WriteToINI = False
On Error GoTo WT_Error
    sFile = App.Path & "\" & INIFile
    L = WritePrivateProfileString(Category, Key, strValue, sFile)
    WriteToINI = True
    
WT_Error:
    If Err.Number <> 0 Then MsgBox "Error while saving configuration: " & Err.Description, vbExclamation, "CloakedChat " & App.Major & "." & App.Minor
End Function

Public Sub LoadPreferences()
    WebbotSetup
End Sub

Public Sub WebbotSetup()
    ConfigBool "Enabled", wbEnabled, "WebChannel"
    ConfigString "URL", wbURL, "WebChannel"
    If LenB(wbURL) = 0 Then wbURL = "http://webbot.ionws.com/"
    If wbEnabled Then
        Set WB = New WebBot
        WB.Initialize KoGBot, wbURL, GetConfig("Username")
    End If
End Sub
