Attribute VB_Name = "Interface"
Option Explicit

'----------------------------------------------------------
'  Major`Bot
'  Interface Module
'----------------------------------------------------------
'  Version 1.2.1 (2004-06-17)
'  1.0.0: Module started, cleaning up and moving other
'         code. (Cloaked)
'  1.1.0: Moved from CSB to BnetBot class, accordingly,
'         added new BotEvent sub for BnetBot.
'  1.1.1: Added Navigate sub. (Cloaked)
'  1.2.0: Added web channel support. (Cloaked)
'  1.2.1: Channel list management redone. (Cloaked)
'----------------------------------------------------------

'----------------------------------------------------------
'  Color Codes
'----------------------------------------------------------
Public Const AtomicBlue = 15571536, vbSilver = &HC0C0C0, WhisperBlue = 12092001, _
    SelfTalkBlue = 16768256

'----------------------------------------------------------
'  Chat Icons
'----------------------------------------------------------
Public Const ICON_BLIZ& = 1
Public Const ICON_BNET& = 2
Public Const ICON_CHAT& = 3
Public Const ICON_D2DV& = 4
Public Const ICON_D2XP& = 5
Public Const ICON_DRTL& = 6
Public Const ICON_DSHR& = 7
Public Const ICON_JSTR& = 8
Public Const ICON_MEGA& = 9
Public Const ICON_OPER& = 10
Public Const ICON_UNKN& = 11
Public Const ICON_SEXP& = 12
Public Const ICON_SPWN& = 13
Public Const ICON_SQEL& = 14
Public Const ICON_SSHR& = 15
Public Const ICON_STAR& = 16
Public Const ICON_W2BN& = 17
Public Const ICON_W3XP& = 18
Public Const ICON_WAR3& = 19

Public Enum verType
    mvTitlebar
End Enum

'----------------------------------------------------------
'  Interface Settings
'----------------------------------------------------------
Public useTimestamps As Boolean, use24HourTimestamps As Boolean, _
    showJoinLeave As Boolean
    
'----------------------------------------------------------
'  Logging
'----------------------------------------------------------
Public Enum LoggingMode
    logAll
    logChat
    logCommands
    logNone
End Enum
Public toLog As LoggingMode
    
'----------------------------------------------------------
'  Other Settings
'----------------------------------------------------------
Public autoMinimizeTray As Boolean

'----------------------------------------------------------
'  Web Channel
'----------------------------------------------------------
Public WB As WebBot
Public wbURL As String, wbEnabled As Boolean

'----------------------------------------------------------
'  News
'----------------------------------------------------------
Private NewsReq As WinHttpRequest
Public FetchingNews As Boolean

'----------------------------------------------------------
'  Channel List
'----------------------------------------------------------
Private NextOp As Long

'----------------------------------------------------------
'  Web Browser
'----------------------------------------------------------
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'----------------------------------------------------------
'  Version String
'  Returns "Major`Bot " and then the current version.
'----------------------------------------------------------
Public Function GetVersion(Optional VT As verType = mvTitlebar) As String
    GetVersion = "Major`Bot " & App.Major & "." & App.Minor
    Select Case mRelease
        Case mrPrivAlpha: GetVersion = GetVersion & " Private Alpha"
        Case mrPrivBeta: GetVersion = GetVersion & " Private Beta"
        Case mrPubAlpha: GetVersion = GetVersion & " Public Alpha"
        Case mrPubBeta: GetVersion = GetVersion & " Public Beta"
        Case mrPrivate: GetVersion = GetVersion & " Private"
        Case mrDevelopment: GetVersion = GetVersion & " Development"
    End Select
End Function

'----------------------------------------------------------
'  Client Icon
'  Returns a code corresponding to an icon appropriate
'  for the client and flags in the icons ImageList.
'  [DEPRECATED] For compatibility with legacy CSB elements.
'----------------------------------------------------------
Public Function GetClientIcon(Client As String, Flags As Long) As Long
    'By Cloaked 5/19/2004
    GetClientIcon = IconCode(ClientStrToKey(Client), Flags)
End Function

'----------------------------------------------------------
'  QuickChannel List Builder
'  Populates the "Quick Channel" list.
'----------------------------------------------------------
Public Function BuildQuickChannel() As Boolean
    Open (App.Path & "\quickchannels.txt") For Input As #1
    Dim z As String, i&
    On Error Resume Next
    For i = 0 To 8
        If EOF(1) Then Exit For
        Input #1, z
        z = Trim$(z)
        With frmMain.mnuQC(i)
            If LenB(z) Then
                .Visible = True
                .Caption = z
            Else
                .Visible = False
            End If
        End With
    Next i
    Close #1
    'Dim F As New File
    'If (F.Load(App.Path & "\quickchannels.txt", fileRead)) Then
    '    Dim R$, i&
    '    For i = 0 To 8
    '        R = F.ReadLine()
    '        If Len(R) Then
    '            With frmMain.mnuQC(i)
    '                .Visible = True
    '                .Caption = R
    '            End With
    '        Else
    '            Exit For
    '        End If
    '    Next i
    '    BuildQuickChannel = True
    '    If F.Unload() = False Then
    '        MsgBox "Error closing file handle: " & F.GetErrorMessage(), _
    '            vbExclamation, GetVersion()
    '    End If
    'Else
    '    MsgBox "Error loading quick channel list: " & F.GetErrorMessage(), _
    '        vbExclamation, GetVersion()
    '    BuildQuickChannel = False
    'End If
End Function

'----------------------------------------------------------
'  Logger
'  Writes log messages to a log file.
'----------------------------------------------------------
Public Sub Logger(ByVal LogString$)
On Error GoTo Log_Error
    If LenB(LogString) = 0 Then Exit Sub
    Open App.Path & "\logs\" & Year(Date) & "-" & Month(Date) & _
        "-" & Day(Date) & ".log" For Append As #4
    'timestamps will always be used
    If use24HourTimestamps Then
        LogString = "[" & Format(Time, "hh:mm:ss") & "] " & LogString
    Else
        LogString = "[" & Format(Time, "h:mm:ss AM/PM") & "] " & LogString
    End If
    Print #4, LogString
    Close #4
Log_Error:
End Sub

'----------------------------------------------------------
'  Navigate
'  Sends the user to the specified URL.
'----------------------------------------------------------
Public Sub Navigate(ByVal URL As String)
    Dim APIReturnCode As Long
    APIReturnCode = ShellExecute(0, "open", URL, "", App.Path, 0)
    If APIReturnCode = 32 Then
        MsgBox "Could not find a file association for " & URL & " on your system. You should check that your browser is correctly installed and associated with this type of file.", vbExclamation, "Browser Unavailable"
    End If
End Sub

'----------------------------------------------------------
'  BotEvent Handler
'  Recieves notices from the Myriad BnetBot class.
'----------------------------------------------------------
Public Sub BotEvent(Key As String, evType As bnEvent, Optional ByVal Text As String = "", _
    Optional ByVal mUser As String = "", Optional ByVal Flags As Long = 0, _
    Optional ByVal Ping As Long = 0, Optional ByVal Extra As String = "")
    Dim lngWork&
    'Event Type
    Select Case evType
        Case evBnlsConnect
            AddC "Connected to BNLS.", vbGreen
            If toLog = logAll Then Logger "Connected to BNLS."
        Case evBnlsConnecting
            AddC "Connecting to BNLS...", vbYellow
            If toLog = logAll Then Logger "Connecting to BNLS..."
        Case evBnlsDisconnect
            'Ignored.
        Case evBot
            '?
        Case evBroadcast
            AddC "Broadcast: " & Text, vbYellow
            If wbEnabled Then WB.BNBroadcast Text
        Case evChannel
            'Never used, see evJoinedChannel.
        Case evConError
            AddC "Error: " & Text, vbRed
            If toLog = logAll Then Logger "Error: " & Text
        Case evConMsg
            AddC Text, vbYellow
            If toLog = logAll Then Logger Text
        Case evConnect
            AddC "Connected to Battle.Net.", vbGreen
            If toLog = logAll Then Logger "Connected to Battle.Net."
        Case evConnecting
            AddC "Connecting to Battle.Net...", vbYellow
            If toLog = logAll Then Logger "Connecting to Battle.Net..."
        Case evDbg
            If mRelease = mrDevelopment Then
                AddC "[Debug] " & Text, vbWhite
                If toLog = logAll Then Logger "[Debug] " & Text
            End If
        Case evDisconnect
            AddC "Disconnected from Battle.Net.", vbRed
            StopIdling
            qStop
            UpdateLocation Key, "", -1
            If toLog = logAll Then Logger "Disconnected from Battle.Net."
        Case evEmote
            'why not? :D
            If (ProcessCommand(Text, mUser) And toLog = logCommands) Then _
                Logger "<" & mUser & " " & Text & ">"
            If Flags And USER_CHANNELOP Then
                AddC_SCColors "<" & mUser & " ", vbWhite, Text, vbWhite, ">"
            Else
                AddC_SCColors "<" & mUser & " ", vbYellow, Text, vbYellow, ">"
            End If
            If toLog = logAll Or toLog = logChat Then _
                Logger "<" & mUser & " " & Text & ">"
            If wbEnabled Then WB.UserEmote mUser, Text, Flags
        Case evError
            AddC Text, vbRed
            If toLog = logAll Or toLog = logChat Then _
                Logger "Battle.Net Error: " & Text
            If wbEnabled Then WB.BNError Text
        Case evGetOps
            If mUser = Bot.RealUsername Then
                AddC "You have received ops.", vbWhite
                If toLog = logAll Or toLog = logChat Then _
                    Logger "You have received ops."
                If wbEnabled Then WB.BNInfo "You have received ops."
            Else
                AddC mUser & " has received ops.", vbWhite
                If toLog = logAll Or toLog = logChat Then _
                    Logger mUser & " has received ops."
                If wbEnabled Then WB.BNInfo mUser & " has received ops."
            End If
        Case evInfo
            lngWork = InStr(Text, " was banned")
            If lngWork > 0 Then
                If IsSafelisted(Mid$(Text, 1, (lngWork - 1))) Then _
                    Bot.Say "/unban " & Mid$(Text, 1, (lngWork - 1)) & " Safelisted"
            End If
            AddC Text, vbYellow
            If toLog = logAll Or toLog = logChat Then _
                Logger "Battle.Net Info: " & Text
            If wbEnabled Then WB.BNInfo Text
        Case evJoin
            If Bot.HasOps And IsShitlisted(mUser) Then
                Bot.Say "/ban " & mUser & " Shitlisted"
            End If
            If showJoinLeave Then _
                AddC mUser & " has joined the channel using " & _
                ClientKeyToName(ClientStrToKey(Text)) & ".", vbGreen
            If toLog = logAll Or toLog = logChat Then
                Logger mUser & " has joined the channel using " & _
                    ClientKeyToName(ClientStrToKey(Text)) & "."
            End If
            AddChannelUser frmMain.lvUsers, mUser, Text, Flags, Ping
            If wbEnabled Then WB.UserJoin mUser, Text, Flags, Ping
        Case evJoinedChannel
            If Flags > 0 Then
                AddC "Joined " & ChannelFlagsToStr(Flags) & " channel " & Text & ".", vbYellow
                If toLog = logAll Or toLog = logChat Then _
                    Logger "Joined " & ChannelFlagsToStr(Flags) & " channel " & Text & "."
            Else
                AddC "Joined normal channel " & Text & ".", vbYellow
                If toLog = logAll Or toLog = logChat Then _
                    Logger "Joined normal channel " & Text & "."
            End If
            ClearChannelUsers frmMain.lvUsers
            If wbEnabled Then WB.JoinChannel Text
        Case evPart
            If showJoinLeave Then _
                AddC mUser & " has left the channel.", vbRed
            If toLog = logAll Or toLog = logChat Then
                Logger mUser & " has left the channel."
            End If
            RemoveChannelUser frmMain.lvUsers, mUser
            If wbEnabled Then WB.UserLeave mUser
        Case evProxyConnect
            AddC "Connected to proxy.", vbWhite
            If toLog = logAll Then Logger "Connected to proxy."
        Case evProxyConnecting
            AddC "Connecting to proxy...", vbWhite
            If toLog = logAll Then Logger "Connecting to proxy..."
        Case evRegisterEmail
            'TODO: Add registration handler.
        Case evSelfTalk
            If Left$(Text, 1) <> "/" Then _
                AddC_SCColors "<" & Bot.RealUsername & "> ", SelfTalkBlue, Text, vbWhite
            If toLog = logAll Or toLog = logChat Then _
                Logger "<" & Bot.RealUsername & "> " & Text
            If wbEnabled Then WB.BotSays Bot.RealUsername, Text
        Case evSuccess
            AddC Text, vbGreen
            If toLog = logAll Then Logger Text
        Case evTalk
            If (ProcessCommand(Text, mUser) And toLog = logCommands) Then _
                Logger "<" & mUser & "> " & Text
            If Flags And USER_CHANNELOP Then
                AddC_SCColors "<" & mUser & "> ", vbWhite, Text, vbWhite
                If toLog = logAll Or toLog = logChat Then _
                    Logger "<" & mUser & " (op)> " & Text
            Else
                AddC_SCColors "<" & mUser & "> ", vbYellow, Text, vbWhite
                If toLog = logAll Or toLog = logChat Then _
                    Logger "<" & mUser & "> " & Text
            End If
            If wbEnabled Then WB.UserSays mUser, Text, Flags
        Case evUser
            AddChannelUser frmMain.lvUsers, mUser, Text, Flags, Ping
            If toLog = logAll Or toLog = logChat Then
                Logger mUser & " is in the channel using " & _
                    ClientKeyToName(ClientStrToKey(Text)) & "."
            End If
            If wbEnabled Then WB.UserPresent mUser, Text, Flags, Ping
        Case evUserFlags
            UpdateChannelUser frmMain.lvUsers, mUser, Text, Flags, Ping
            If (Flags And USER_CHANNELOP) Then BotEvent Key, evGetOps, , mUser
            If wbEnabled Then WB.UserFlags mUser, Flags
        Case evWhisperRecv
            If (ProcessCommand(Text, mUser) And toLog = logCommands) Then _
                Logger "<From: " & mUser & "> " & Text
            AddC_SCColors "<From: " & mUser & "> ", WhisperBlue, Text, vbSilver
            If toLog = logAll Or toLog = logChat Then _
                Logger "<From: " & mUser & "> " & Text
            If wbEnabled Then WB.WhisperRecv mUser, Text
        Case evWhisperSend
            AddC_SCColors "<To: " & mUser & "> ", WhisperBlue, Text, vbSilver
            If toLog = logAll Or toLog = logChat Then _
                Logger "<To: " & mUser & "> " & Text
            If wbEnabled Then WB.WhisperSend mUser, Text
    End Select
End Sub

Public Sub RequestProfile(Username As String)
    Dim Keys(3) As String
    Keys(0) = "Profile\Age"
    Keys(1) = "Profile\Sex"
    Keys(2) = "Profile\Location"
    Keys(3) = "Profile\Description"
    Bot.RequestProfile Username, Keys
End Sub

Public Sub ProfileReceived(bKey As String, Username As String, Keys() As String, _
    Values() As String)
    Dim P As frmProfile, i&
    Set P = New frmProfile
    
    With P
        For i = 0 To UBound(Keys)
            Select Case Keys(i)
                Case "Profile\Age": .setAge Values(i)
                Case "Profile\Sex": .setSex Values(i)
                Case "Profile\Location": .setLocation Values(i)
                Case "Profile\Description": .setDescription Values(i)
            End Select
        Next i
        
        .setUser Username
        .setBotKey bKey
        If Bot.Username = Username Then
            .setEditable True
        Else
            .setEditable False
        End If
        .DlgDraw
    End With

End Sub

Public Sub InvitedToClan(ByVal Key$, ByVal Cookie&, ByVal ClanTagRaw As Long, _
    ByVal ClanTag$, ByVal ClanName$, ByVal InvitingUser$)
    
End Sub

Public Function FetchNews() As Boolean
    Set NewsReq = New WinHttpRequest
    With NewsReq
        .Open "GET", "http://www.majorbot.bnetweb.com/botnews/?version=" & App.Major & "." & App.Minor, True
        .Send
    End With
    FetchingNews = True
    FetchNews = True
End Function

Public Function HasNewsArrived() As Boolean
On Error GoTo HNA_Error
    HasNewsArrived = False
    If NewsReq.Status > 0 Then
        HasNewsArrived = True
    End If
    Exit Function
HNA_Error:
    HasNewsArrived = False
End Function

Public Function NewsAvailable() As Boolean
On Error GoTo NA_Error
    NewsAvailable = False
    If NewsReq.Status = 200 Then NewsAvailable = True
    Exit Function
NA_Error:
    NewsAvailable = False
End Function

Public Function GetNews() As String
    GetNews = NewsReq.ResponseText
End Function

Public Sub NewsCleanup()
    Set NewsReq = Nothing
End Sub

Public Function ClientStrToKey(strClient As String) As bnProduct
    Select Case strClient
        Case "STAR": ClientStrToKey = bpStarCraft
        Case "SEXP": ClientStrToKey = bpBroodWar
        Case "D2DV": ClientStrToKey = bpDiablo2
        Case "D2XP": ClientStrToKey = bpDiablo2x
        Case "W2BN": ClientStrToKey = bpWarCraft2
        Case "WAR2": ClientStrToKey = bpWarCraft2 'for stupid people
        Case "WAR3": ClientStrToKey = bpWarCraft3
        Case "W3XP": ClientStrToKey = bpWarCraft3x
        Case "JSTR": ClientStrToKey = bpStarCraftJapan
        'Myriad does not support any clients below here.
        Case "SSHR": ClientStrToKey = bpStarCraftSW
        Case "DRTL": ClientStrToKey = bpDiablo
        Case "DSHR": ClientStrToKey = bpDiabloSW
        Case "BLIZ": ClientStrToKey = bpBlizzard
        Case "BNET": ClientStrToKey = bpBnetRep
    End Select
End Function

Public Function ClientKeyToStr(Client As bnProduct) As String
    Select Case Client
        Case bpStarCraft: ClientKeyToStr = "STAR"
        Case bpBroodWar: ClientKeyToStr = "SEXP"
        Case bpDiablo2: ClientKeyToStr = "D2DV"
        Case bpDiablo2x: ClientKeyToStr = "D2XP"
        Case bpWarCraft2: ClientKeyToStr = "W2BN"
        Case bpWarCraft3: ClientKeyToStr = "WAR3"
        Case bpWarCraft3x: ClientKeyToStr = "W3XP"
    End Select
End Function

Public Function ClientKeyToIcon(Key As bnProduct) As Long
    Select Case Key
        Case bpBlizzard: ClientKeyToIcon = ICON_BLIZ
        Case bpBnetRep: ClientKeyToIcon = ICON_BNET
        Case bpBroodWar: ClientKeyToIcon = ICON_SEXP
        Case bpChat: ClientKeyToIcon = ICON_CHAT
        Case bpDiablo: ClientKeyToIcon = ICON_DRTL
        Case bpDiabloSW: ClientKeyToIcon = ICON_DSHR
        Case bpDiablo2: ClientKeyToIcon = ICON_D2DV
        Case bpDiablo2x: ClientKeyToIcon = ICON_D2XP
        Case bpStarCraft: ClientKeyToIcon = ICON_STAR
        Case bpStarCraftJapan: ClientKeyToIcon = ICON_JSTR
        Case bpStarCraftSW: ClientKeyToIcon = ICON_SSHR
        Case bpWarCraft2: ClientKeyToIcon = ICON_W2BN
        Case bpWarCraft3: ClientKeyToIcon = ICON_WAR3
        Case bpWarCraft3x: ClientKeyToIcon = ICON_W3XP
        Case Else: ClientKeyToIcon = ICON_UNKN
    End Select
End Function

Public Function ClientKeyToName(Key As bnProduct) As String
    Select Case Key
        Case bpBlizzard: ClientKeyToName = "a Blizzard Rep. client"
        Case bpBnetRep: ClientKeyToName = "a Battle.Net admin client"
        Case bpBroodWar: ClientKeyToName = "Brood War"
        Case bpChat: ClientKeyToName = "a chat client"
        Case bpDiablo: ClientKeyToName = "Diablo"
        Case bpDiabloSW: ClientKeyToName = "Diablo Shareware"
        Case bpDiablo2: ClientKeyToName = "Diablo II"
        Case bpDiablo2x: ClientKeyToName = "Diablo II: Lord of Descruction"
        Case bpStarCraft: ClientKeyToName = "StarCraft"
        Case bpStarCraftJapan: ClientKeyToName = "StarCraft Japan"
        Case bpStarCraftSW: ClientKeyToName = "StarCraft Shareware"
        Case bpWarCraft2: ClientKeyToName = "WarCraft II BNE"
        Case bpWarCraft3: ClientKeyToName = "WarCraft III"
        Case bpWarCraft3x: ClientKeyToName = "WarCraft III: The Frozen Throne"
        Case Else: ClientKeyToName = "an unknown client"
    End Select
End Function

'Used in frmSetup
Public Function ClientNameToKey(Name As String) As bnProduct
    Select Case Name
        Case "Brood War": ClientNameToKey = bpBroodWar
        Case "Diablo II": ClientNameToKey = bpDiablo2
        Case "Diablo II: Lord of Descruction": ClientNameToKey = bpDiablo2x
        Case "StarCraft": ClientNameToKey = bpStarCraft
        Case "WarCraft II BNE": ClientNameToKey = bpWarCraft2
        Case "WarCraft III": ClientNameToKey = bpWarCraft3
        Case "WarCraft III: The Frozen Throne": ClientNameToKey = bpWarCraft3x
    End Select
End Function

Public Function ChannelFlagsToStr(Flags As Long) As String
    'Select Case Flags
    '    Case CHANNEL_GLOBAL: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    '    Case CHANNEL_: ChannelFlagsToStr = ""
    'End Select
    'Dim strT As String * 4
    'CopyMemory strT, ByVal Flags, 4
    If (Flags And CHANNEL_GLOBAL) = CHANNEL_GLOBAL Then
        ChannelFlagsToStr = "global"
    ElseIf (Flags And CHANNEL_MODERATED) = CHANNEL_MODERATED Then
        ChannelFlagsToStr = "moderated"
    ElseIf (Flags And CHANNEL_PUBLIC) Then
        ChannelFlagsToStr = "public"
    ElseIf (Flags And CHANNEL_RESTRICTED) Then
        ChannelFlagsToStr = "restricted"
    ElseIf (Flags And CHANNEL_PRODUCTSPECIFIC) Then
        ChannelFlagsToStr = "product-specific"
    ElseIf (Flags And CHANNEL_SILENT) Then
        ChannelFlagsToStr = "silent"
    ElseIf (Flags And CHANNEL_SYSTEM) Then
        ChannelFlagsToStr = "system"
    Else
        ChannelFlagsToStr = "unknown"
    End If
End Function

Public Function IconCode(Product As bnProduct, Flags As Long) As Long
    IconCode = ClientKeyToIcon(Product)
    If (Flags And USER_CHANNELOP) Then IconCode = ICON_OPER
    If (Flags And USER_SPEAKER) Then IconCode = ICON_MEGA
    If (Flags And USER_SQUELCHED) Then IconCode = ICON_SQEL
    If (Flags And USER_ADMIN) Then IconCode = ICON_BNET
    If (Flags And USER_BLIZZREP) Then IconCode = ICON_BLIZ
End Function

Public Sub AddChannelUser(L As ListView, Username As String, Client As String, _
    Flags As Long, Ping As Long)
On Error GoTo ACU_Error
    If Flags And USER_CHANNELOP Then
        NextOp = NextOp + 1
        With L.ListItems.Add(NextOp, "cu_" & Username, Username, , _
            IconCode(ClientStrToKey(Client), Flags))
            .ForeColor = vbWhite
            .SubItems(1) = Ping & "ms"
        End With
    Else
        With L.ListItems.Add(, "cu_" & Username, Username, , _
            IconCode(ClientStrToKey(Client), Flags))
            .ForeColor = vbYellow
            .SubItems(1) = Ping & "ms"
        End With
    End If
ACU_Error:
End Sub

Public Sub RemoveChannelUser(L As ListView, Username As String)
On Error GoTo RCU_Error
    L.ListItems.Remove "cu_" & Username
RCU_Error:
End Sub

Public Sub UpdateChannelUser(L As ListView, Username As String, _
    Client As String, Flags As Long, Ping As Long)
On Error GoTo UCU_Error
    Dim i&
    If Flags And USER_CHANNELOP Then
        RemoveChannelUser L, Username
        AddChannelUser L, Username, Client, Flags, Ping
    Else
        L.ListItems("cu_" & Username).SmallIcon = _
            IconCode(ClientStrToKey(Client), Flags)
    End If
UCU_Error:
End Sub

Public Sub ClearChannelUsers(L As ListView)
    NextOp = 0
    L.ListItems.Clear
End Sub

Public Sub Remove()

End Sub

'Public Sub AddChannelUser(L As ListView, Username As String, _
'    Client As String, Flags As Long, Ping As Long)
'
'    If Flags And USER_CHANNELOP Then
'        With L.ListItems.Add(1, "cu_" & Username, Username, _
'            , GetClientIcon(Client, Flags))
'
'            .ForeColor = vbWhite
'            .SubItems(1) = Ping & "ms"
'            .Tag = Username
'        End With
'    Else
'        With L.ListItems.Add(, "cu_" & Username, Username, _
'            , GetClientIcon(Client, Flags))
'
'            .ForeColor = vbYellow
'            .SubItems(1) = Ping & "ms"
'            .Tag = Username
'        End With
'    End If
'End Sub

'Public Sub AddChannelUser(L As ListView, Username As String, _
    Client As String, Flags As Long, Ping As Long)
'On Error Resume Next
'    Dim i&
'    If Flags And USER_CHANNELOP Then
'        'trigger list rebuild
'        Bot.BuildChannelList L
'    Else
'        i = L.ListItems.Count + 1
'        L.ListItems.Add i, "cu_" & Username, Username, , GetClientIcon(Client, Flags)
'        L.ListItems(i).ForeColor = vbYellow
'        L.ListItems(i).SubItems(1) = Ping & "ms"
'        L.ListItems(i).Tag = Username
'    End If
'End Sub

'Public Sub RemoveChannelUser(L As ListView, Username As String)
'On Error Resume Next
'    L.ListItems.Remove "cu_" & Username
'End Sub

'Public Sub UpdateChannelUser(L As ListView, Username As String, _
'    Flags As Long)
'On Error Resume Next
'    L.ListItems("cu_ " & Username).SmallIcon = GetClientIcon("", Flags)
'End Sub

'Public Sub ClearChannelUsers(L As ListView)
'On Error Resume Next
'    L.ListItems.Clear
'End Sub

Public Sub UpdateLocation(BotKey As String, Channel As String, Users As Integer)
    If Users > -1 Then
        frmMain.lblChannel = Channel & " (" & Users & ")"
        frmMain.Caption = GetVersion() & " Running " & Bot.RealUsername & " in " & Channel
        frmMain.sysTray.TrayTip = GetVersion() & " Running " & Bot.RealUsername & " in " & Channel
    Else
        frmMain.lblChannel = ""
        frmMain.Caption = GetVersion()
        frmMain.sysTray.TrayTip = GetVersion()
        ClearChannelUsers frmMain.lvUsers
    End If
End Sub

Public Sub NotifyUserMove(Bot As String, Action As Long)
    'Do nothing.
End Sub

'----------------------------------------------------------
'  Text Adder
'  Adds text to the chat window.
'----------------------------------------------------------
Public Sub AddC(ParamArray saElements() As Variant)
    Dim i&
    
    If useTimestamps Then
        With frmMain.rtbChannel
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = vbWhite
            If use24HourTimestamps Then
                .SelText = "[" & Format(Time, "hh:mm:ss") & "] "
            Else
                .SelText = "[" & Format(Time, "h:mm:ss AM/PM") & "] "
            End If
            .SelStart = Len(.Text)
        End With
    End If
    For i = LBound(saElements) To UBound(saElements) Step 2
        With frmMain.rtbChannel
            .SelStart = Len(.Text)
            .SelLength = 0
            If (i + 1) <= UBound(saElements) Then
                .SelColor = saElements(i + 1)
            Else
                .SelColor = vbWhite
            End If
            .SelText = CStr(saElements(i))
            .SelStart = Len(.Text)
        End With
    Next i
    With frmMain.rtbChannel
      .SelStart = Len(.Text)
      .SelLength = 0
      .SelColor = vbWhite
      .SelText = vbCrLf
    End With
End Sub

'----------------------------------------------------------
'  Text Adder With StarCraft Color Codes
'  Adds text to the chat window and processes StarCraft
'  color codes.
'----------------------------------------------------------
Public Sub AddC_SCColors(sText As String, sColor As Long, ByVal Message As String, _
    mColor As ColorConstants, Optional eText As String = "")
    '-----------------------------------------------------'
    ' From Myriad 1.0 Private Alpha                       '
    ' By Cloaked                                          '
    '-----------------------------------------------------'
    Dim i&, L&, CC As Long, ct As String, cChar As String
    'Do some initializing.
    i = 1
    L = Len(Message)
    ct = ""
    CC = mColor
    
    
    With frmMain.rtbChannel
        'Timestamp
        If useTimestamps Then
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = vbWhite
            If use24HourTimestamps Then
                .SelText = "[" & Format(Time, "hh:mm:ss") & "] "
            Else
                .SelText = "[" & Format(Time, "h:mm:ss AM/PM") & "] "
            End If
        End If

        'Starting text
        .SelStart = Len(.Text)
        .SelLength = 0
        .SelColor = sColor
        .SelText = sText
    End With
    
    'Main message loop
    While i <= L
        cChar = Mid$(Message, i, 1)
        If cChar = "" Then
            'Color detection
            With frmMain.rtbChannel
                .SelStart = Len(.Text)
                .SelLength = 0
                .SelColor = CC
                .SelText = ct
            End With
            ct = ""
            i = i + 1
            CC = SCColorToVBColor(Mid$(Message, i, 1), sColor)
        ElseIf Mid$(Message, i, 2) = "Á" Then
            'Crude support for the accented A represented in UTF-8 (?)
            With frmMain.rtbChannel
                .SelStart = Len(.Text)
                .SelLength = 0
                .SelColor = CC
                .SelText = ct
            End With
            ct = ""
            i = i + 2
            CC = SCColorToVBColor(Mid$(Message, i, 1), sColor)
        Else
            ct = ct & cChar
        End If
        i = i + 1
    Wend
    With frmMain.rtbChannel
        'Flush what's left in the message buffer
        .SelStart = Len(.Text)
        .SelLength = 0
        .SelColor = CC
        .SelText = ct
        'Add newline characters
        If Len(eText) = 0 Then
            eText = vbCrLf
        Else
            eText = eText & vbCrLf
        End If
        'Add ending text
        .SelStart = Len(.Text)
        .SelLength = 0
        .SelColor = sColor
        .SelText = eText
    End With
End Sub

Private Function SCColorToVBColor(ColorCode As String, Optional ByVal Default& = vbWhite) As Long
    Select Case ColorCode
        Case "Y": SCColorToVBColor = vbRed
        Case "U", "T", "V": SCColorToVBColor = vbCyan
        Case "S", "X", "Z": SCColorToVBColor = vbYellow
        Case "R": SCColorToVBColor = vbGreen
        Case "P", "W": SCColorToVBColor = vbWhite
        Case "Q": SCColorToVBColor = &H808080
        Case Else: SCColorToVBColor = Default
    End Select
End Function

Public Function StrToHex(ByVal String1 As String) As String
On Error Resume Next
    Dim strTemp As String, strReturn As String, i As Long
    
    For i = 1 To Len(String1)
        strTemp = Hex(Asc(Mid(String1, i, 1)))
        If Len(strTemp) = 1 Then strTemp = "0" & strTemp
        If i = 1 Then
            strReturn = strTemp
        Else
            strReturn = strReturn & " " & strTemp
        End If
    Next i
    StrToHex = strReturn
End Function

Public Function ConvertTime(ByVal lngMS As Long) As String
    Dim lngSeconds As Long, lngDays As Long, lngHours As Long, lngMins As Long
    Dim strSeconds As String, strDays As String
    lngSeconds = lngMS / 1000
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds Mod 86400
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds Mod 3600
    lngMins = Int(lngSeconds / 60)
    lngSeconds = lngSeconds Mod 60
    If lngSeconds <> 1 Then strSeconds = "s"
    If lngDays <> 1 Then strDays = "s"
    ConvertTime = lngDays & " day" & strDays & ", " & lngHours & " hours, " & lngMins & " minutes and " & lngSeconds & " second" & strSeconds
End Function

Public Function ConvertTimeCondensed(ByVal lngMS As Long) As String
    Dim lngSeconds As Long, lngDays As Long, lngHours As Long, lngMins As Long
    lngSeconds = lngMS / 1000
    lngDays = Int(lngSeconds / 86400)
    lngSeconds = lngSeconds Mod 86400
    lngHours = Int(lngSeconds / 3600)
    lngSeconds = lngSeconds Mod 3600
    lngMins = Int(lngSeconds / 60)
    lngSeconds = lngSeconds Mod 60
    
    ConvertTimeCondensed = ""
    
    If lngDays = 1 Then
        ConvertTimeCondensed = lngDays & " day "
    ElseIf lngDays > 1 Then
        ConvertTimeCondensed = lngDays & " days "
    End If
    
    If lngHours < 10 Then _
        ConvertTimeCondensed = ConvertTimeCondensed & "0"
    ConvertTimeCondensed = ConvertTimeCondensed & lngHours & ":"
    
    If lngMins < 10 Then _
        ConvertTimeCondensed = ConvertTimeCondensed & "0"
    ConvertTimeCondensed = ConvertTimeCondensed & lngMins & ":"
    
    If lngSeconds < 10 Then _
        ConvertTimeCondensed = ConvertTimeCondensed & "0"
    ConvertTimeCondensed = ConvertTimeCondensed & lngSeconds
End Function
