Attribute VB_Name = "MajorBot"
Option Explicit

'----------------------------------------------------------
'  Major`Bot
'  Controller Module
'----------------------------------------------------------
'  Version 1.0.0 (2004-05-19)
'  1.0.0: Module started, cleaning up and moving other
'         code. (Cloaked)
'----------------------------------------------------------

'----------------------------------------------------------
'  Release Type
'----------------------------------------------------------
Public Enum releaseType
    mrStable
    mrPrivate
    mrPrivAlpha
    mrPrivBeta
    mrPubAlpha
    mrPubBeta
    mrDevelopment
End Enum
Public mRelease As releaseType

'----------------------------------------------------------
'  Anti-Idle
'----------------------------------------------------------
Public Enum IdleTypes
    idleMessage
    idleUptime
    idleQuotes
    idleMp3
    idleBot
End Enum
Public idleType As IdleTypes, idleDelay As Long, idleMsg As String, _
    idleTimer As Long
Private LastIdleTick As Long
Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, _
    ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, _
    ByVal uIDEvent As Long) As Long

'----------------------------------------------------------
'  Status
'----------------------------------------------------------
Public isConnected As Boolean, isConnecting As Boolean
Public useSafelist As Boolean, useTagbans As Boolean, useAutoBan As Boolean
Public startupTime As Long

'----------------------------------------------------------
'  Myriad's BnetBot
'----------------------------------------------------------
Public Bot As New BnetBot
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function RawMyriadDLLVersion Lib "myriad.dll" _
    Alias "MyriadDLLVersion" () As Long


'----------------------------------------------------------
'  Main Sub
'  This sub is run when the bot starts up.
'----------------------------------------------------------
Sub Main()
On Error Resume Next
    'Set release type.
    mRelease = mrStable
    
    'Record startup time.
    startupTime = GetTickCount()
    
    'Seed random number generator.
    Randomize
    
    'Check myriad.dll version.
    If Not CheckMyriadDLLVersion(1, 6) Then
        MsgBox "Major`Bot failed to start.  The required DLL " & _
            "myriad.dll was either not found or is too old to use.", _
            vbCritical, GetVersion()
        End
    End If
    
    'Load and show splash screen.
    Load frmSplash
    frmSplash.Show
    DoEvents
    
    'Load main form.
    Dim strTmp$
    Load frmMain
    With frmMain
        .Caption = GetVersion()
        .sysTray.TrayTip = GetVersion()
        showJoinLeave = GetBoolean("JoinLeave", "Preferences", True)
        .mnuSettingsJoinLeave.Checked = showJoinLeave
        useTimestamps = GetBoolean("Timestamps", "Preferences", True)
        .mnuSettingsTimestampsEnabled.Checked = useTimestamps
        use24HourTimestamps = GetBoolean("24HourTimestamps", "Preferences")
        .mnuSettingsTimestamps24Hour.Checked = use24HourTimestamps
        autoMinimizeTray = GetBoolean("MinimizeToTray", "Preferences")
        .mnuSettingsAutoTray.Checked = autoMinimizeTray
        BuildQuickChannel
        strTmp = LCase$(GetConfig("LogMode", "Preferences"))
        Select Case strTmp
            Case "all"
                .mnuSettingsLoggingAll.Checked = True
                toLog = logAll
            Case "chat"
                toLog = logChat
                .mnuSettingsLoggingChat.Checked = True
            Case "commands"
                toLog = logCommands
                .mnuSettingsLoggingCommands.Checked = True
            Case Else
                toLog = logNone
                .mnuSettingsLoggingDisabled.Checked = True
        End Select
        
        LoadDatabase "access.txt"
                
        .onResize
        AddC "Welcome to " & GetVersion(), vbGreen
        AddC "Please report any bugs to scope@bnetweb.com, and " & _
            "visit www.bnetweb.com for updates.", vbWhite
    End With
    
    Dim wsaStart As WSADataType
    Dim i&, W&, WSSD As String, WSS As Boolean
    W = Winsock.WSACleanup
    If (WSAStartup(&H22, wsaStart) <> 0) Then
        MsgBox "Fatal Error: Could not initialize Winsock.", vbCritical, GetVersion()
        End
    Else
        BotEvent "", evDbg, "Winsock initialized."
    End If
    LoadPreferences
    frmMain.Show
    frmSplash.Hide
    FetchNews
End Sub

'----------------------------------------------------------
'  Connect
'  Run this sub to connect the bot.
'----------------------------------------------------------
Public Sub ConnectBot()
    If isConnected Then _
        Bot.Disconnect
        
    isConnected = False
    
    Dim strActive$, doConnect As Boolean, doRealm As Boolean
    doConnect = True
    doRealm = False
    
    With Bot
        .bKey = "majorbot"
        
        'The Not inverts the boolean (i.e. True becomes False)
        .UseBNLS = Not GetBoolean("Hashed")
        
        strActive = GetConfig("Username")
        If LenB(strActive) = 0 Then
            AddC "Error: You must enter a username.", vbRed
            doConnect = False
        Else
            .Username = strActive
        End If
        
        strActive = GetConfig("Password")
        If LenB(strActive) = 0 Then
            AddC "Error: You must enter a password.", vbRed
            doConnect = False
        Else
            .Password = strActive
        End If
        
        strActive = GetConfig("CDKey")
        If LenB(strActive) = 0 Then
            AddC "Error: You must enter a CD-key.", vbRed
            doConnect = False
        Else
            .CDKey = strActive
        End If
        
        strActive = GetConfig("Product")
        If LenB(strActive) = 0 Then
            AddC "Error: You must enter a product.", vbRed
            doConnect = False
        Else
            .Client = ClientStrToKey(strActive)
            Select Case strActive
                Case "STAR", "SEXP"
                    Bot.Hash1 = GetConfig("star_exe", "Hashes")
                    Bot.Hash2 = GetConfig("star_dll", "Hashes")
                    Bot.Hash3 = GetConfig("star_snp", "Hashes")
                Case "W2BN", "WAR2" 'WAR2: stupid ppl only!
                    Bot.Hash1 = GetConfig("w2bn_exe", "Hashes")
                    Bot.Hash2 = GetConfig("w2bn_dll", "Hashes")
                    Bot.Hash3 = GetConfig("w2bn_snp", "Hashes")
                Case "D2DV"
                    Bot.Hash1 = GetConfig("d2dv_exe", "Hashes")
                    Bot.Hash2 = GetConfig("d2dv_bnc", "Hashes")
                    Bot.Hash3 = GetConfig("d2dv_d2c", "Hashes")
                Case "D2XP"
                    Bot.Hash1 = GetConfig("d2xp_exe", "Hashes")
                    Bot.Hash2 = GetConfig("d2xp_bnc", "Hashes")
                    Bot.Hash3 = GetConfig("d2xp_d2c", "Hashes")
            End Select
        End If
        
        If .Client = bpDiablo2x Or .Client = bpWarCraft3x Then
            strActive = GetConfig("ExCDKey")
            If LenB(strActive) = 0 Then
                AddC "Error: You must enter an expansion CD-key.", vbRed
                doConnect = False
            Else
                .ExCDKey = strActive
            End If
        End If
        
        strActive = GetConfig("Server")
        If LenB(strActive) = 0 Then
            AddC "Error: You must enter a server.", vbRed
            doConnect = False
        Else
            .Server = strActive
        End If
        
        strActive = GetConfig("HomeChan")
        If LenB(strActive) = 0 Then
            AddC "Warning: No home channel specified.  Using default.", vbYellow
            .Home = "Public Chat Major`Bot"
        Else
            .Home = strActive
        End If
        
        strActive = GetConfig("Trigger")
        If LenB(strActive) = 0 Then
            AddC "Warning: No trigger specified.  Using default trigger of ""!"".", vbYellow
            Trigger = "!"
        Else
            Trigger = strActive
        End If
        
        Master = GetConfig("Master")

        'strActive = GetConfig("File", "Database")
        'If LenB(strActive) = 0 Then
        '    'silently use a default
        '    LoadDatabase "access.txt"
        'Else
        '    LoadDatabase strActive
        'End If
        
        '*** does not support realms (as of 5-20-2004)
        'If GetBoolean("UseRealm") Then
        '    strActive = GetConfig("Character")
        '    If LenB(strActive) = 0 Then
        '        AddC frmMain.Talk, vbYellow, "Warning: Can not use Diablo II realms.  You must specify a character."
        '        doRealm = False
        '    Else
        '        .Character = strActive
        '    End If
        '
        '    strActive = GetConfig("Realm")
        '    If LenB(strActive) = 0 Then
        '        AddC frmMain.Talk, vbYellow, "Warning: Can not use Diablo II realms.  You must specify a realm."
        '        doRealm = False
        '    Else
        '        .Realm = strActive
        '    End If
        '    .UseRealm = doRealm
        'End If
        
        '*** always uses udp (as of 5-20-2004)
        '.UseUDP = GetBoolean("UseUDP", "Main", True)
        'UseIdle = GetBoolean("Idle")
        useAutoBan = GetBoolean("AutoBan")
        useSafelist = GetBoolean("Safelist")
        useTagbans = GetBoolean("Tagbans")
    End With

    If doConnect Then
        isConnecting = True
        Bot.Connect
        qStart
        LoadIdle
    End If
End Sub

'----------------------------------------------------------
'  Disconnect
'  Run this sub to disconnect the bot.
'----------------------------------------------------------
Public Sub DisconnectBot()
    Bot.Disconnect
    qStop
End Sub

Public Sub LoadIdle()
    Select Case LCase$(GetConfig("Mode", "Idle"))
        Case "mp3"
            idleType = idleMp3
        Case "bot", "version"
            idleType = idleBot
        Case "message", "custom"
            idleType = idleMessage
        Case "quote", "quotes"
            idleType = idleQuotes
        Case "uptime"
            idleType = idleUptime
        Case Else
            idleType = idleMessage
    End Select
    Select Case LCase$(GetConfig("Unit", "Idle"))
        Case "sec", "seconds", "second"
            idleDelay = 1000 * CLng(Val(GetConfig("Delay", "Idle")))
        Case Else
            idleDelay = 60000 * CLng(Val(GetConfig("Delay", "Idle")))
    End Select
    idleMsg = GetConfig("Message", "Idle")
    If idleDelay > 0 Then _
        StartIdling
End Sub

Public Sub StartIdling()
    If idleDelay > 0 Then
        idleTimer = SetTimer(0, idleTimer, idleDelay, AddressOf IdleTick)
    Else
        StopIdling
    End If
End Sub

Public Sub StopIdling()
    If idleTimer Then
        KillTimer 0, idleTimer
        idleTimer = 0
    End If
End Sub

Private Sub IdleTick(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
    If Not IsQueueBusy() Then
        LastIdleTick = dwTime
        qAdd GenerateIdleMessage()
    End If
End Sub

Public Function GenerateIdleMessage() As String
    Select Case idleType
        Case idleMp3
            If WinampVer > 0 Then
                GenerateIdleMessage = GetSong()
            Else
                GenerateIdleMessage = "(Winamp not loaded.)"
            End If
        Case idleBot
            GenerateIdleMessage = GetVersion() & " by Scope.  Anti-Idle"
        Case idleMessage
            GenerateIdleMessage = idleMsg
        Case idleQuotes
            'TODO
        Case idleUptime
            GenerateIdleMessage = "System uptime: " & _
                ConvertTimeCondensed(GetTickCount()) & _
                "; Bot Uptime: " & _
                ConvertTimeCondensed(GetTickCount() - startupTime)
    End Select
End Function

'----------------------------------------------------------
'  Random Number
'  Get a random number between Low and High.
'----------------------------------------------------------
Public Function Rand(ByVal Low As Long, _
                     ByVal High As Long) As Long
  Rand = Int((High - Low + 1) * Rnd) + Low
End Function

'----------------------------------------------------------
'  Myriad.dll Utilities
'----------------------------------------------------------

Public Function GetMyriadDLLVersion() As String
On Error GoTo Ver_Error
    Dim rV As Long, wPart(1) As Integer
    rV = RawMyriadDLLVersion()
    CopyMemory wPart(0), rV, 4
    GetMyriadDLLVersion = wPart(0) & "." & wPart(1)
    Exit Function
Ver_Error:
    GetMyriadDLLVersion = "[Could not retrieve version.]"
End Function

Public Function CheckMyriadDLLVersion(ByVal Major As Integer, ByVal Minor As Integer, _
    Optional ByVal Strict As Boolean = False) As Boolean
On Error GoTo Chk_Error
    Dim rV As Long, wPart(1) As Integer
    rV = RawMyriadDLLVersion()
    CopyMemory wPart(0), rV, 4

    If Strict Then
        If wPart(0) = Major And wPart(1) = Minor Then
            CheckMyriadDLLVersion = True
        Else
            CheckMyriadDLLVersion = False
        End If
    Else
        If wPart(0) > Major Then
            CheckMyriadDLLVersion = True
        ElseIf wPart(0) = Major And wPart(1) >= Minor Then
            CheckMyriadDLLVersion = True
        Else
            CheckMyriadDLLVersion = False
        End If
    End If
    Exit Function
Chk_Error:
    CheckMyriadDLLVersion = False
End Function
