Attribute VB_Name = "PacketConstants"
Option Explicit

'----------------------------------------------------------
'  BNLS Packets
'----------------------------------------------------------
Public Const BNLS_NULL& = &H0
Public Const BNLS_CDKEY& = &H1
Public Const BNLS_LOGONCHALLENGE& = &H2
Public Const BNLS_LOGONPROOF& = &H3
Public Const BNLS_CREATEACCOUNT& = &H4
Public Const BNLS_CHANGECHALLENGE& = &H5
Public Const BNLS_CHANGEPROOF& = &H6
Public Const BNLS_UPGRADECHALLENGE& = &H7
Public Const BNLS_UPGRADEPROOF& = &H8
Public Const BNLS_VERSIONCHECK& = &H9
Public Const BNLS_CONFIRMLOGON& = &HA
Public Const BNLS_HASHDATA& = &HB
Public Const BNLS_CDKEY_EX& = &HC
Public Const BNLS_CHOOSENLSREVISION& = &HD
Public Const BNLS_AUTHORIZE& = &HE
Public Const BNLS_AUTHORIZEPROOF& = &HF
Public Const BNLS_REQUESTVERSIONBYTE& = &H10
Public Const BNLS_VERIFYSERVER& = &H11
Public Const BNLS_RESERVESERVERSLOTS& = &H12
Public Const BNLS_SERVERLOGONCHALLENGE& = &H13
Public Const BNLS_SERVERLOGONPROOF& = &H14

'----------------------------------------------------------
'  Realm (MCP) Packets
'----------------------------------------------------------
Public Const MCP_STARTUP& = &H1
Public Const MCP_CHARCREATE& = &H2
Public Const MCP_CHARLOGON& = &H7
Public Const MCP_CHARDELETE& = &HA
Public Const MCP_MOTD& = &H12
Public Const MCP_CHARLIST& = &H19
Public Const MCP_CHARUPGRADE& = &H18

'----------------------------------------------------------
'  BNCS Packets
'----------------------------------------------------------
Public Const SID_NULL& = &H0
Public Const SID_CLIENTID& = &H5
Public Const SID_STARTVERSIONING& = &H6
Public Const SID_REPORTVERSION& = &H7
Public Const SID_GETADVLISTEX& = &H9
Public Const SID_ENTERCHAT& = &HA
Public Const SID_GETCHANNELLIST& = &HB
Public Const SID_JOINCHANNEL& = &HC
Public Const SID_CHATCOMMAND& = &HE
Public Const SID_CHATEVENT& = &HF
Public Const SID_FLOODDETECTED& = &H13
Public Const SID_UDPPINGRESPONSE& = &H14
Public Const SID_MESSAGEBOX& = &H19
Public Const SID_PING& = &H25
Public Const SID_READUSERDATA& = &H26
Public Const SID_WRITEUSERDATA& = &H27
Public Const SID_LOGONCHALLENGE& = &H28
Public Const SID_LOGONRESPONSE& = &H29
Public Const SID_CREATEACCOUNT& = &H2A
Public Const SID_CHANGEPASSWORD& = &H31
Public Const SID_LOGONRESPONSE2& = &H3A
Public Const SID_CREATEACCOUNT2& = &H3D
Public Const SID_LOGONREALMEX& = &H3E
Public Const SID_REALMINIT& = &H40
Public Const SID_AUTH_INFO& = &H50
Public Const SID_AUTH_CHECK& = &H51
Public Const SID_AUTH_ACCOUNTCREATE& = &H52
Public Const SID_AUTH_ACCOUNTLOGON& = &H53
Public Const SID_AUTH_ACCOUNTLOGONPROOF& = &H54
Public Const SID_AUTH_ACCOUNTCHANGE& = &H55
Public Const SID_AUTH_ACCOUNTCHANGEPROOF& = &H56
Public Const SID_AUTH_ACCOUNTUPGRADE& = &H57
Public Const SID_AUTH_ACCOUNTUPGRADEPROOF& = &H58
Public Const SID_AUTH_REGISTEREMAIL& = &H59
Public Const SID_FRIENDLIST& = &H65
Public Const SID_FRIENDUPDATE& = &H66
Public Const SID_FRIENDADDED& = &H67
Public Const SID_FRIENDREMOVED& = &H68
Public Const SID_FRIENDMOVED& = &H69
Public Const SID_FINDCLANCANDIDATES& = &H70
Public Const SID_INVITEMULTIPLEUSERS& = &H71
Public Const SID_DISBANDCLAN& = &H73
Public Const SID_CLANINFO& = &H75
Public Const SID_CLANREQUEST& = &H77
Public Const SID_CLANINVITE& = &H79
Public Const SID_CLANMOTD& = &H7C
Public Const SID_CLANMEMBERLIST& = &H7D
Public Const SID_CLANMEMBERUPDATE& = &H7F

'----------------------------------------------------------
'  SID_CHATEVENT Events
'----------------------------------------------------------
Public Const EID_SHOWUSER& = &H1
Public Const EID_JOIN& = &H2
Public Const EID_LEAVE& = &H3
Public Const EID_WHISPER& = &H4
Public Const EID_TALK& = &H5
Public Const EID_BROADCAST& = &H6
Public Const EID_CHANNEL& = &H7
Public Const EID_USERFLAGS& = &H9
Public Const EID_WHISPERSENT& = &HA
Public Const EID_CHANNELFULL& = &HD
Public Const EID_CHANNELDOESNOTEXIST& = &HE
Public Const EID_CHANNELRESTRICTED& = &HF
Public Const EID_INFO& = &H12
Public Const EID_ERROR& = &H13
Public Const EID_EMOTE& = &H17

'----------------------------------------------------------
'  User Flags
'----------------------------------------------------------
Public Const USER_BLIZZREP& = &H1
Public Const USER_CHANNELOP& = &H2
Public Const USER_SPEAKER& = &H4
Public Const USER_ADMIN& = &H8
Public Const USER_NOUDP& = &H10
Public Const USER_BEEPENABLED& = &H100
Public Const USER_KBKOFFICIAL& = &H1000
Public Const USER_JAILED& = &H100000
Public Const USER_SQUELCHED& = &H20
Public Const USER_PGLPLAYER& = &H200
Public Const USER_GFPLAYER& = &H200000
Public Const USER_GUEST& = &H40
Public Const USER_PGLOFFICIAL& = &H400
Public Const USER_KBKPLAYER& = &H800

'----------------------------------------------------------
'  Channel Flags
'----------------------------------------------------------
Public Const CHANNEL_PUBLIC& = &H1
Public Const CHANNEL_MODERATED& = &H2
Public Const CHANNEL_RESTRICTED& = &H4
Public Const CHANNEL_SILENT& = &H8
Public Const CHANNEL_SYSTEM& = &H10
Public Const CHANNEL_GLOBAL& = &H1000
Public Const CHANNEL_PRODUCTSPECIFIC& = &H20

'----------------------------------------------------------
'  Clan Rank Flags
'----------------------------------------------------------
Public Const RANK_NEW_PEON As Byte = &H0
Public Const RANK_PEON As Byte = &H1
Public Const RANK_GRUNT As Byte = &H2
Public Const RANK_SHAMAN As Byte = &H3
Public Const RANK_CHIEFTAIN As Byte = &H4

'----------------------------------------------------------
'  Game Types
'----------------------------------------------------------
Public Const GAME_MELEE% = &H2
Public Const GAME_FFA% = &H3
Public Const GAME_1V1% = &H4
Public Const GAME_CTF% = &H5
Public Const GAME_GREED% = &H6
Public Const GAME_SLAUGHTER% = &H7
Public Const GAME_SUDDENDEATH% = &H8
Public Const GAME_LADDER% = &H9
Public Const GAME_IRONMAN% = &H10
Public Const GAME_UMS% = &HA
Public Const GAME_TEAMMELEE% = &HB
Public Const GAME_TEAMFFA% = &HC
Public Const GAME_TEAMCTF% = &HD
Public Const GAME_TVB% = &HE
