Attribute VB_Name = "Queue"
Option Explicit

'----------------------------------------------------------
'  Queue System
'----------------------------------------------------------

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, _
    ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, _
    ByVal uIDEvent As Long) As Long
Private mTimerId As Long, qData As New Collection, qSize&, LastSend&, LastLen&

Private Const QUEUE_BUSY_THRESHOLD& = 5

Private Sub QueueTick(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
    Dim Delay&
    If qSize = 0 Then Exit Sub
    If LastLen <= 4 Then
        Delay = 1750
    ElseIf LastLen > 4 And LastLen <= 15 Then
        Delay = 2150
    ElseIf LastLen > 15 And LastLen <= 25 Then
        Delay = 2750
    Else
        Delay = 3250
    End If
    If (LastSend + Delay) <= dwTime Then
        qSendNext dwTime
    End If
End Sub

Public Function IsQueueBusy() As Boolean
    If qSize >= QUEUE_BUSY_THRESHOLD Then
        IsQueueBusy = True
    Else
        IsQueueBusy = False
    End If
End Function

Public Sub qAdd(ByVal Message As String)
    qSize = qSize + 1
    qData.Add Message
End Sub

Public Sub qDel(Optional ByVal Index As Long = 1)
    qSize = qSize - 1
    qData.Remove Index
End Sub

Private Sub qSendNext(ByVal CurTC As Long)
    LastSend = CurTC
    If qSize = 0 Then Exit Sub
    Bot.Say NextQueueMessage()
End Sub

Public Sub qStart()
    mTimerId = SetTimer(0, 0, 10, AddressOf QueueTick)
End Sub

Public Sub qStop()
    If mTimerId > 0 Then _
        KillTimer 0, mTimerId
    mTimerId = 0
End Sub

Private Function NextQueueMessage() As String
    If qSize = 0 Then
        NextQueueMessage = ""
    Else
        NextQueueMessage = qData(1)
        qDel
        LastLen = Len(NextQueueMessage)
    End If
End Function
'Send Logic:
'If (LastTick + Delay) <= Now

'Delay Logic:
'

'Private Function RequiredDelay(ByVal Bytes As Long) As Long
'    Dim Tick&
'    Const PerPacket = 200
'    Const PerByte = 10
'    Const MaxBytes = 600
'   Tick = GetTickCount()
'    'If difference between now and our last-sent message
'    'is greater than the required delay based on the length
'    'of the last-sent message...
'    If (Tick - LastSend) > (LastLen * PerByte) Then
'        '... set last message length to 0.
'        LastLen = 0
'    'Otherwise...
'    Else
'        '... subtract the number of bytes that the current
'        'delay has covered.
'        LastLen = LastLen - ((Tick - LastSend) * PerByte)
'    End If
'
'
'End Function

'*******************************************************************
' If this returns non-zero, delay that many milliseconds
'  before trying again. If this returns zero, send your data.
'*******************************************************************
'Private Function RequiredDelay(ByVal Bytes As Long) As Long
'    Static LastTick As Long
'    Static SentBytes As Long
'    Const PerPacket = 200
'    Const PerByte = 10
'    Const MaxBytes = 600
'    Dim Tick As Long
'    Tick = GetTickCount()
'    If (Tick - LastTick) > (SentBytes * PerByte) Then
'        SentBytes = 0
'    Else
'        SentBytes = SentBytes - (Tick - LastTick) / PerByte
'    End If
'    LastTick = Tick
'    If (SentBytes + PerPacket + Bytes) > MaxBytes Then
'        RequiredDelay = (SentBytes + PerPacket + Bytes - MaxBytes) * PerByte
'    Else
'        SentBytes = SentBytes + PerPacket + Bytes
'        RequiredDelay = 0
'    End If
'End Function

'Private Sub QueueSend(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
'    Dim myMessage$, msDelay&
'    myMessage = NextQueueMessage()
'    If LenB(myMessage) = 0 Then
'        KillTimer 0, mTimerId
'        Exit Sub
'    End If
'    msDelay = RequiredDelay(Len(myMessage))
'    If msDelay = 0 Then
'        Bot.Say myMessage
'    Else
'        mTimerId = SetTimer(0, 0, msDelay, AddressOf QueueSend)
'       'mTimerId = CreateTimer(RequiredDelay, AddressOf QueueSend)
'    End If
'End Sub

'Private Sub QueueSendEmpty(ByVal Message As String)
'    Dim msDelay&
'    msDelay = RequiredDelay(Len(Message))
'    If msDelay = 0 Then
'        Bot.Say Message
'    Else
'
'End Sub
